package edu.ucla.cs.SMOsTranslator;

import java.util.Iterator;

import org.jgrapht.UndirectedGraph;
import org.jgrapht.graph.SimpleGraph;

/**
 * Build an Isolation graph
 * An Isolation Graph represent a set of {@link TableDependenciesGraph} graphs. 
 * Up to now the graph is not really used. A list could have been enough, but for possible future implementation a graph of graph is created
 * If a table dependencies is added, only an edge between two vertex must be added in the graph, easily allowing the statements merging  
 * @author fangar
 *
 */
public class IsolationGraph {
	
	
	private UndirectedGraph<TableDependenciesGraph, DependenciesGraphEdge> isolationGraph; 
		 

	/**
	 * Public constructor
	 */
	public IsolationGraph(){
		isolationGraph = new SimpleGraph<TableDependenciesGraph, DependenciesGraphEdge>(DependenciesGraphEdge.class);
	}
	
	/**
	 * Add a vertex ({@link TableDependenciesGraph} to the isolation graph
	 * @param t
	 */
	public void addSubgraph(TableDependenciesGraph t){
		this.isolationGraph.addVertex(t);
	}
	
//	public Set<TableDependenciesGraph> getTableDependenciesVertex(){
//		return this.isolationGraph.vertexSet();
//	}
	
	
	/**
	 * Return an iterator over the graph's vertexes
	 */
	public Iterator<TableDependenciesGraph> iterator(){
		return this.isolationGraph.vertexSet().iterator();
	}
	
	
}
