package edu.ucla.cs.SMOsTranslator.Pattern;

import edu.ucla.cs.db.prism.backend.schema.Schema;

public class PatternFactory {

	public enum PatternType{
		JOIN1,
		JOIN2,
		MERGE,
		DECOMPOSE,
		PARTITION1
//		PARTITION2
	}


	/**
	 * Create an instance of each pattern defined in {@link PatternFactory}
	 * @param patternType
	 * @param schema
	 * @return
	 */
	public static Pattern createPattern(PatternType patternType, Schema schema){
		
		switch(patternType){
			case JOIN1: 
				return new JoinPattern(schema);
			case JOIN2:
				return new JoinPattern2(schema);
			case MERGE:
				return new MergePattern(schema);
			case DECOMPOSE:
				return new DecomposePattern(schema);
			case PARTITION1:
				return new PartitionPattern1(schema);
//			case PARTITION2:
//				return new PartitionPattern2(schema);
		}
		throw new IllegalArgumentException("The Pattern you are trying to create doesn not exist");
	}


}
