package edu.ucla.cs.SMOsTranslator.Pattern;

import net.sf.jsqlparser.statement.Statement;
import net.sf.jsqlparser.statement.alter.table.AlterTableAddColumnStatement;
import net.sf.jsqlparser.statement.alter.table.AlterTableChangeColumnStatement;
import net.sf.jsqlparser.statement.alter.table.AlterTableDropColumnStatement;
import net.sf.jsqlparser.statement.alter.table.AlterTableModifyColumnStatement;
import net.sf.jsqlparser.statement.alter.table.AlterTableStatement;
import net.sf.jsqlparser.statement.create.table.CreateTable;
import net.sf.jsqlparser.statement.delete.Delete;
import net.sf.jsqlparser.statement.drop.DropTable;
import net.sf.jsqlparser.statement.insert.Insert;
import net.sf.jsqlparser.statement.update.Update;

public class StatementLabelGenerator {

	
	public static String getStatementLabel(Statement stmt){

		if(stmt instanceof CreateTable){
			return Pattern.CREATE_TAB;
		}
		else if(stmt instanceof AlterTableStatement){
			if (stmt instanceof AlterTableModifyColumnStatement){
				return Pattern.ALTER_MODIFY;
			}
			else if(stmt instanceof AlterTableDropColumnStatement){
				return Pattern.ALTER_DROP;
			}
			else if(stmt instanceof AlterTableChangeColumnStatement){
				return Pattern.ALTER_CHANGE;
			}
			else if(stmt instanceof AlterTableAddColumnStatement){
				return Pattern.ALTER_ADD_COL;
			}
		}
		else if(stmt instanceof DropTable){
			return Pattern.DROP_TAB;
		}
		else if(stmt instanceof Insert){
			return Pattern.INSERT;
		}
		else if(stmt instanceof Update){
			return Pattern.UPDATE;
		}
		else if(stmt instanceof Delete){
			return Pattern.DELETE;
		}
		return "XXXX";
	}
	
	
	
}
