package edu.ucla.cs.SMOsTranslator.Pattern.visitor;

import java.util.ArrayList;

import net.sf.jsqlparser.schema.Column;
import net.sf.jsqlparser.statement.StatementVisitor;
import net.sf.jsqlparser.statement.alter.table.AlterTableStatement;
import net.sf.jsqlparser.statement.create.table.ColumnDefinition;
import net.sf.jsqlparser.statement.create.table.CreateTable;
import net.sf.jsqlparser.statement.delete.Delete;
import net.sf.jsqlparser.statement.drop.DropTable;
import net.sf.jsqlparser.statement.insert.Insert;
import net.sf.jsqlparser.statement.replace.Replace;
import net.sf.jsqlparser.statement.select.ColumnIndex;
import net.sf.jsqlparser.statement.select.ColumnReferenceVisitor;
import net.sf.jsqlparser.statement.select.Select;
import net.sf.jsqlparser.statement.truncate.Truncate;
import net.sf.jsqlparser.statement.update.Update;


/**
 * Extract the {@link Column} for the current statement
 * @author fangar
 *
 */
public class CreateTableExtractColumnsVisitor implements StatementVisitor, ColumnReferenceVisitor{

	
	private ArrayList<Column> columnsFromCreateTable;
	
		
	public ArrayList<Column> getColumnsFromCreateTable(CreateTable create) {
		columnsFromCreateTable = new ArrayList<Column>();
		create.accept(this);
		return columnsFromCreateTable;
	}
	
	
	@Override
	public void visit(Column column){
		columnsFromCreateTable.add(column);
	}

	@Override
	public void visit(Insert insert) {
		// TODO Auto-generated method stub
	}
	
	
	@Override
	public void visit(Delete arg0) {
		// TODO Auto-generated method stub
		
	}


	@Override
	public void visit(CreateTable create) {
		for(ColumnDefinition colDef: create.getColumnDefinitions()){
			colDef.getColumnName().accept(this);
		}
		
	}


	@Override
	public void visit(AlterTableStatement arg0) {
		// TODO Auto-generated method stub
		
	}


	@Override
	public void visit(Replace arg0) {
		// TODO Auto-generated method stub
		
	}


	@Override
	public void visit(Select arg0) {
		// TODO Auto-generated method stub
		
	}


	@Override
	public void visit(Update arg0) {
		// TODO Auto-generated method stub
		
	}


	@Override
	public void visit(Truncate arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void visit(DropTable drop) {
		// TODO Auto-generated method stub
		
	}




	@Override
	public void visit(ColumnIndex columnIndex) {
		// TODO Auto-generated method stub
		
	}

}
