package edu.ucla.cs.SMOsTranslator.Pattern.visitor;

import java.util.ArrayList;
import java.util.List;

import net.sf.jsqlparser.expression.operators.relational.ExpressionList;
import net.sf.jsqlparser.expression.operators.relational.ItemsListVisitor;
import net.sf.jsqlparser.schema.Table;
import net.sf.jsqlparser.statement.StatementVisitor;
import net.sf.jsqlparser.statement.alter.table.AlterTableStatement;
import net.sf.jsqlparser.statement.create.table.CreateTable;
import net.sf.jsqlparser.statement.delete.Delete;
import net.sf.jsqlparser.statement.drop.DropTable;
import net.sf.jsqlparser.statement.insert.Insert;
import net.sf.jsqlparser.statement.replace.Replace;
import net.sf.jsqlparser.statement.select.FromItemVisitor;
import net.sf.jsqlparser.statement.select.Join;
import net.sf.jsqlparser.statement.select.PlainSelect;
import net.sf.jsqlparser.statement.select.Select;
import net.sf.jsqlparser.statement.select.SelectVisitor;
import net.sf.jsqlparser.statement.select.SubJoin;
import net.sf.jsqlparser.statement.select.SubSelect;
import net.sf.jsqlparser.statement.select.Union;
import net.sf.jsqlparser.statement.truncate.Truncate;
import net.sf.jsqlparser.statement.update.Update;

public class SourceTableVisitor implements StatementVisitor, FromItemVisitor,SelectVisitor,ItemsListVisitor{

	
	private ArrayList<Table> sourceTables;
	
	public ArrayList<Table> getTablesFromInsert(Insert insert) {
		sourceTables = new ArrayList<Table>();
		insert.accept(this);
		return sourceTables;
	}
	
	public void visit(SubSelect subSelect){
		subSelect.getSelectBody().accept(this);
	}
	
	public void visit(PlainSelect plainSelect){
		plainSelect.getFromItem().accept(this);
		
		if(plainSelect.getJoins() != null){
			List<Join> joins = plainSelect.getJoins();
			for(Join j: joins){
				j.getRightItem().accept(this);
			}
		}
	}
	

	
	public void visit(Table table){
		sourceTables.add(table);
	}
	
	@Override
	public void visit(Insert insert) {
		insert.getItemsList().accept(this);
	}

	@Override
	public void visit(SubJoin subjoin) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void visit(Union union) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void visit(ExpressionList expressionList) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void visit(Delete delete) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void visit(CreateTable create) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void visit(AlterTableStatement alter) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void visit(Replace replace) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void visit(Select select) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void visit(Update update) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void visit(Truncate truncate) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void visit(DropTable drop) {
		// TODO Auto-generated method stub
		
	}


	
}
