package edu.ucla.cs.SMOsTranslator.Pattern.visitor;

import edu.ucla.cs.SMOsTranslator.Pattern.Pattern;
import net.sf.jsqlparser.statement.Statement;
import net.sf.jsqlparser.statement.StatementVisitor;
import net.sf.jsqlparser.statement.alter.table.AlterTableAddColumnStatement;
import net.sf.jsqlparser.statement.alter.table.AlterTableAlterColumnStatement;
import net.sf.jsqlparser.statement.alter.table.AlterTableChangeColumnStatement;
import net.sf.jsqlparser.statement.alter.table.AlterTableDropColumnStatement;
import net.sf.jsqlparser.statement.alter.table.AlterTableModifyColumnStatement;
import net.sf.jsqlparser.statement.alter.table.AlterTableStatement;
import net.sf.jsqlparser.statement.alter.table.AlterTableStatementVisitor;
import net.sf.jsqlparser.statement.create.table.CreateTable;
import net.sf.jsqlparser.statement.delete.Delete;
import net.sf.jsqlparser.statement.drop.DropTable;
import net.sf.jsqlparser.statement.insert.Insert;
import net.sf.jsqlparser.statement.replace.Replace;
import net.sf.jsqlparser.statement.select.Select;
import net.sf.jsqlparser.statement.truncate.Truncate;
import net.sf.jsqlparser.statement.update.Update;

public class StatementLabelVisitor implements StatementVisitor, AlterTableStatementVisitor{

	private String statementLabel;
	
	public String getStatementLabel(Statement stmt){
		stmt.accept(this);
		return statementLabel;
	}
	
	@Override
	public void visit(Insert insert) {
		this.statementLabel = Pattern.INSERT;
	}

	@Override
	public void visit(Delete delete) {
		this.statementLabel = Pattern.DELETE;
	}

	@Override
	public void visit(CreateTable create) {
		this.statementLabel = Pattern.CREATE_TAB;
	}

	@Override
	//FIXME
	public void visit(AlterTableStatement alter) {
		this.statementLabel = Pattern.ALTER_ADD_COL;
	}

	@Override
	public void visit(Replace replace) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void visit(Select select) {
		//TODO Auto-generated method stub
	}

	@Override
	public void visit(Update update) {
		this.statementLabel = Pattern.UPDATE;
	}

	@Override
	public void visit(Truncate truncate) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void visit(DropTable drop) {
		this.statementLabel = Pattern.DROP_TAB;
	}

	@Override
	public void visit(AlterTableAddColumnStatement stmt) {
		this.statementLabel = Pattern.ALTER_ADD_COL;
	}

	@Override
	public void visit(AlterTableAlterColumnStatement stmt) {
		// TODO Auto-generated method stub
	}

	@Override
	public void visit(AlterTableChangeColumnStatement stmt) {
		this.statementLabel = Pattern.ALTER_CHANGE;
	}

	@Override
	public void visit(AlterTableDropColumnStatement stmt) {
		this.statementLabel = Pattern.ALTER_DROP;		
	}

	@Override
	public void visit(AlterTableModifyColumnStatement stmt) {
		this.statementLabel = Pattern.ALTER_MODIFY;
	}
	
}
