package edu.ucla.cs.SMOsTranslator.TestCase;

import java.util.ArrayList;

import junit.framework.TestCase;
import net.sf.jsqlparser.schema.Column;
import net.sf.jsqlparser.schema.Index;
import net.sf.jsqlparser.schema.Table;
import net.sf.jsqlparser.schema.datatypes.StringDataType;
import net.sf.jsqlparser.statement.create.table.ColumnDefinition;
import net.sf.jsqlparser.statement.create.table.CreateTable;
import edu.ucla.cs.SMOsTranslator.CreateTranslator.CreateTableStatementTranslator;

public class CreateTableTestCase extends TestCase {

	
	public void testCreateTableTranslation(){
		CreateTable stmt = new CreateTable();
		Table table = new Table();
		table.setName("tabella");
		stmt.setTable(table);
		ColumnDefinition colDef = new ColumnDefinition();
		StringDataType type = new StringDataType();
		type.setDataTypeName("varchar(20)");
		type.setLength(20);
		Column col = new Column();
		col.setColumnName("colonna");
		colDef.setColumnName(col);
		colDef.setColDataType(type);
		
		ArrayList<ColumnDefinition> cols = new ArrayList<ColumnDefinition>();
		cols.add(colDef);
		
		stmt.setColumnDefinitions(cols);
		
		
		Index index = new Index();
		index.setType("PRIMARY KEY");
		index.setName("PRIMARY");
		ArrayList<String> columnNames = new ArrayList<String>();
		columnNames.add("a");
		index.setColumnsNames(columnNames);
		
		ArrayList<Index> indexes = new ArrayList<Index>();
		indexes.add(index);
		
		stmt.setIndexes(indexes);
		
		CreateTableStatementTranslator trans = new CreateTableStatementTranslator();
		
		assertEquals("CREATE TABLE tabella(colonna varchar(20));",trans.translateStatement(stmt).get(0));
		assertEquals("ALTER TABLE tabella ADD PRIMARY KEY \"PRIMARY\" (a) CHECK;",trans.translateStatement(stmt).get(1)); 
	}
	
	public static void main(String[] args){
		junit.swingui.TestRunner.run(CreateTableTestCase.class);
	}
	
}
