package edu.ucla.cs.db.prism.backend;
import java.io.File;

import main.GlobalObjects;
import main.MainUtil;
import main.MainVisitor;


public class MarsMain
{
    static void runCodi(Object state[], String args[]) {
		File pref =  new File(System.getProperty("user.dir"));
	
		GlobalObjects globO = new GlobalObjects (//new parser.CodiTreeVisitor(pref),
							 new deBruijn.deBruijnVisitor(),
							 new deBruijn.Context());
		
		MainVisitor m = new MainVisitor (globO);
		
		long phase1 = System.currentTimeMillis ();	
		coditree.Node t = (coditree.Node) MainUtil.includeSourceFile (args[0], pref, null);		
		
		deBruijn.Pair pr = (deBruijn.Pair) t.accept (globO.deBVisitor, globO.context);
		coditree.Node first = (coditree.Node) pr.getFirst();
		
	
		long phase2 = System.currentTimeMillis ();	
		
		state = (Object[]) first.accept (m, state);
		long phase3 = System.currentTimeMillis ();	
		
		System.out.println ("Time for parsing: "+(phase2-phase1)+" ms");
		System.out.println ("Time for semantics + execution: "+(phase3-phase2)+" ms");
	    }//runCodi


    public static void main(String args[]) {
		if (args.length != 1) {
		    System.err.println ("Usage: java MarsMain <source-file-name>");
		    System.exit (1);
		}
		Object[] state = new Object[3];
		state[0] = new deBruijn.Context();
		state[1] = new normalize.RuleContainer();
		state[2] = new normalize.EvalContextContainer();
		runCodi (state, args);

    }//edu.ucla.db.prim()
}//class Main4

