package edu.ucla.cs.db.prism.backend;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import edu.ucla.cs.db.prism.backend.util.db.DBUtil;

public class QueryLoader {
	
	Connection conn = null;
	String schemaName = null;
	String metaDB = null;
	
	public QueryLoader(Connection conn, String schemaName, String metaDB){
		this.conn = conn;	
		this.schemaName = schemaName;	
		this.metaDB = metaDB;
	}
	
	public String[] loadQueryTemplatesFromDB(int targetVersion) {	
		
		String schemataQuery = "SELECT pattern_text FROM " + metaDB +".QUERY_PATTERN q WHERE q.target_version = " +targetVersion+ " AND q.schema_name = \"" + schemaName +"\" AND active<>0;";
		ResultSet rs = DBUtil.executeSQLQuery(schemataQuery,conn);
		Vector<String> queries = new Vector<String>();
		try {
			while(rs.next()){
				queries.add(rs.getString("pattern_text"));
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		String[] ret = new String[queries.size()];
		for(int i = 0 ; i< ret.length; i++){
			ret[i] = queries.elementAt(i);
		}
		System.out.println("QUERY LOADED: " + ret.length);
		return ret;
	
	}
}
