package edu.ucla.cs.db.prism.backend.SQL;
import java.io.Serializable;
import java.util.Vector;

public class FromClause implements Serializable {
	static final long serialVersionUID = 0;
	public Vector<RelationDeclaration> relationDeclarations;

	public FromClause() {
		relationDeclarations = new Vector<RelationDeclaration>();
	}

	@Override
	public FromClause clone() {
		FromClause newFromClause = new FromClause();
		for(int i=0; i<relationDeclarations.size(); i++) 
			newFromClause.relationDeclarations.add(this.relationDeclarations.get(i).clone());
		return newFromClause;
	}
	
	public void addRelationDeclaration(RelationDeclaration rd) {
		relationDeclarations.add(rd);
	}
/*
	public String getRelationAlias(String relation) {
		for(int i=0; i<relationDeclarations.size(); i++) {
			if(relation.contentEquals(relationDeclarations.get(i).getRelation()))
				return relationDeclarations.get(i).getRelationAlias();
		}
		return null;
	}
*/
	public String getRelationAlias(int id) {
		for(int i=0; i<relationDeclarations.size(); i++) {
			if(id == relationDeclarations.get(i).getId())
				return relationDeclarations.get(i).getRelationAlias();
		}
		return null;
	}
	public String getRelation(String relationAlias) {
		if(relationAlias == null) return null;
		for(int i=0; i<relationDeclarations.size(); i++) {
			if(relationAlias.contentEquals(relationDeclarations.get(i).getRelationAlias()))
				return relationDeclarations.get(i).getRelation();
		}
		return null;
	}	
	
	public Vector<RelationDeclaration> getRelationDeclarationsByRelation(String relationName) {
		
		Vector<RelationDeclaration> rdSet = new Vector<RelationDeclaration>();
		for(int i=0; i<relationDeclarationsSize(); i++) {
			RelationDeclaration rd = relationDeclarations.get(i);
			if(rd.relation.equals(relationName))
				rdSet.add(rd);
		}
		return rdSet;
	}
	
	public Vector<RelationDeclaration> getRelationDeclarationsByRelationPrefix(String relationName) {
		
		Vector<RelationDeclaration> rdSet = new Vector<RelationDeclaration>();
		for(int i=0; i<relationDeclarationsSize(); i++) {
			RelationDeclaration rd = relationDeclarations.get(i);
			if(rd.relation.startsWith(relationName))
				rdSet.add(rd);
		}
		return rdSet;
	}
	
	// return relation declaration that has relation starting with relationNamePrefix
	public Vector<RelationDeclaration> getRelationDeclarationsStartingWith(String relationNamePrefix) {
		
		Vector<RelationDeclaration> rdSet = new Vector<RelationDeclaration>();
		for(int i=0; i<relationDeclarationsSize(); i++)
			if(relationDeclarations.get(i).relation.startsWith(relationNamePrefix))
				rdSet.add(getRelationDeclaration(i));
		return rdSet;
	}
	
	public RelationDeclaration getRelationDeclaration(String relationAlias) {
		if(relationAlias == null) return null;
		for(int i=0; i<relationDeclarations.size(); i++) {
			if(relationAlias.contentEquals(relationDeclarations.get(i).getRelationAlias()))
				return relationDeclarations.get(i);
		}
		return null;
	}
	
	public RelationDeclaration getRelationDeclaration(int index) {
		return relationDeclarations.get(index);
	}
	
	public int relationDeclarationsSize() {
		return relationDeclarations.size();
	}
	
	// MARS output decode
	public void decodePredicateNames() {
		for(int i=0; i<relationDeclarations.size(); i++)
			relationDeclarations.get(i).decodePredicateName();
	}
	
	public void setIds() {
		for(int i=0; i<relationDeclarations.size(); i++)
			relationDeclarations.get(i).setId(i);
	}
	
	
	
	
	// 6/15/2007
	// needed for xquery-SQL unified RSV computatin (required source version)
	public Vector<String> getRelationAliases() {
		Vector<String> relationAliases = new Vector<String>();
		for(int i=0; i<relationDeclarations.size(); i++) {
			relationAliases.add(relationDeclarations.get(i).relationAlias);
		}
		return relationAliases;
	}
	
	
	
	

	@Override
	public String toString() {
		String result = "FROM ";
		int i;
		
		for(i=0; i<relationDeclarations.size()-1; i++)
			result += relationDeclarations.get(i).toString() + ", ";
		result += relationDeclarations.get(i).toString();
		
		return result;
	}
	public String toStringDebugging() {
		String result = "FROM ";
		int i;
		
		for(i=0; i<relationDeclarations.size()-1; i++)
			result += relationDeclarations.get(i).toStringDebugging() + ", ";
		result += relationDeclarations.get(i).toStringDebugging();
		
		return result;
	}

	public String toViewString(String dbstring) {
		String result = "FROM ";
		int i;
		
		for(i=0; i<relationDeclarations.size()-1; i++)
			result += relationDeclarations.get(i).toViewString(dbstring) + ", ";
		result += relationDeclarations.get(i).toViewString(dbstring);
		
		return result;
	}

	public String toTablesOnlyString() {
		String result = "";
		int i;
		for(i=0; i<relationDeclarations.size()-1; i++)
			result += relationDeclarations.get(i).toViewString(null) + ", ";
		result += relationDeclarations.get(i).toViewString(null);
		return result;
	}

	public String toAliasString() {
		String result = "";
		int i;
		for(i=0; i<relationDeclarations.size()-1; i++)
			result += relationDeclarations.get(i).relationAlias + ", ";
		result += relationDeclarations.get(i).relationAlias;
		return result;
	}
}
