package edu.ucla.cs.db.prism.backend.SQL;

import java.io.Serializable;
import java.util.Vector;

// SQL constraint
public class SQLC implements Serializable {
	static final long serialVersionUID=0;
	
	Vector<RelationDeclaration> all;
	Vector<WhereCondition> ifClause;
	Vector<RelationDeclaration> some;
	Vector<WhereCondition> thenClause;

	public SQLC(Vector<RelationDeclaration> all,
				Vector<WhereCondition> ifClause,
				Vector<RelationDeclaration> some,
				Vector<WhereCondition> thenClause) {
		
		this.all = all;
		this.ifClause = ifClause;
		this.some = some;
		this.thenClause = thenClause;
		setRelationDeclarationIds();
	}

	/*
	public String getRelationAlias(String relation) {
		if(all == null)
			return null;
		for(int i=0; i<all.size(); i++) {
			if(relation.contentEquals(all.get(i).getRelation()))
				return all.get(i).getRelationAlias();
		}
		if(some == null)
			return null;
		for(int i=0; i<some.size(); i++) {
			if(relation.contentEquals(some.get(i).getRelation()))
				return some.get(i).getRelationAlias();
		}
		
		return null;
	}
	*/
	public String getRelationAlias(int id) {
		if(all == null)
			return null;
		for(int i=0; i<all.size(); i++) {
			if(id == all.get(i).getId())
				return all.get(i).getRelationAlias();
		}
		if(some == null)
			return null;
		for(int i=0; i<some.size(); i++) {
			if(id == some.get(i).getId())
				return some.get(i).getRelationAlias();
		}
		
		return null;
	}
	
	public String getRelation(String relationAlias) {
		if(all == null)
			return null;
		for(int i=0; i<all.size(); i++) {
			if(relationAlias.contentEquals(all.get(i).getRelationAlias()))
				return all.get(i).getRelation();
		}
		if(some == null)
			return null;
		for(int i=0; i<some.size(); i++) {
			if(relationAlias.contentEquals(some.get(i).getRelationAlias()))
				return some.get(i).getRelation();
		}		
		return null;
	}	
	
	public void setRelationDeclarationIds() {
		int id=0;
		
		if(all == null) return;
		for(int i=0; i<all.size(); i++) {
			all.get(i).setId(id++);
		}

		if(some == null) return;
		for(int i=0; i<some.size(); i++) {
			some.get(i).setId(id++);
		}
	}
	
	@Override
	public String toString() {
		String result = "";
		int i;
		
		if(all != null) {
			for(i=0; i<all.size(); i++) {
				result += "all (" + all.get(i).toStringConstraintStyle() + ") ";
			}
		}
		
		if(ifClause != null) {
			if(ifClause.size() > 0)
				result += "if ";
			for(i=0; i<ifClause.size()-1; i++) {
				result += ifClause.get(i).toString() + " AND ";
			}
			if(ifClause.size() > 0) {
				result += ifClause.get(i).toString() + " then ";
			}
		}

		if(some != null) {
			for(i=0; i<some.size(); i++) {
				result += "some (" + some.get(i).toStringConstraintStyle() + ") ";
			}
		}
		
		if(thenClause != null) {
			for(i=0; i<thenClause.size()-1; i++) {
				result += thenClause.get(i).toString() + " AND ";
			}
			if(thenClause.size() > 0)
				result += thenClause.get(i).toString() + " ";
			else if(thenClause.size() == 0)
				result += "false ";
		}
		
		result = result.substring(0, result.length()-1) + ";";
		return result;
		
	}
	
}
