package edu.ucla.cs.db.prism.backend.SQL;
import java.util.Vector;

public class SQLUnion {
	public Vector<SQL> sqls;
	public WithClause with; // moved from SQL - Hyun 2008-05-21
	public String name;
	public int version;
	
	public SQLUnion() {
		sqls = new Vector<SQL>();
		with = new WithClause();
	}
	
	@Override
	public SQLUnion clone() {
		SQLUnion newSQLUnion = new SQLUnion();
		newSQLUnion.with = this.with.clone();
		for(int i=0; i<sqls.size(); i++) {
			newSQLUnion.sqls.add(this.sqls.get(i).clone());
		}
		newSQLUnion.name = this.name;
		newSQLUnion.version = this.version;
		return newSQLUnion;
	}
	
	public void versionTag(int version,int minor_version) {
		for(int i=0; i<this.sqls.size(); i++) {
			this.sqls.get(i).versionTag(version,minor_version);
		}
	}
	public void versionTag(String tag) {
		for(int i=0; i<this.sqls.size(); i++) {
			this.sqls.get(i).versionTag(tag);
		}
	}
	public void versionUntag() {
		for(int i=0; i<this.sqls.size(); i++) {
			this.sqls.get(i).versionUntag();
		}
	}
	
	public void simplify() {
		with.simplify();
		for(int i=0; i<sqls.size(); i++)
			sqls.get(i).simplify();
	}
	
	public void removeTautologies() {
		for(int i=0; i<sqls.size(); i++)
			sqls.get(i).removeTautologies();
	}
	
	
	public void convertFunctionToREF(int targetVersion, int targetVersionMinor) {
		for(int i=0; i<sqls.size(); i++){
			SQL s = sqls.get(i);
			if(s != null)
				s.convertFunctionToREF(targetVersion, targetVersionMinor);
		}
	}
	public void convertInequalityToREF(int targetVersion, int targetVersionMinor) {
		for(int i=0; i<sqls.size(); i++){
			SQL s = sqls.get(i);
			if(s != null)
				s.convertInequalityToREF(targetVersion, targetVersionMinor);
		}
	}
	public void convertREFToInequality(int targetVersion, int targetVersionMinor) {
		for(int i=0; i<sqls.size(); i++){
			SQL s = sqls.get(i);
			if(s != null)
				s.convertREFToInequality(targetVersion, targetVersionMinor);
		}
	}
	public void convertREFToFunction(int targetVersion, int targetVersionMinor) {
		for(int i=0; i<sqls.size(); i++){
			SQL s = sqls.get(i);
			if(s != null)
				s.convertREFToFunction(targetVersion, targetVersionMinor);
		}	
	}
	
	@Override
	public String toString() {
		String str = "";
		str += with.toString();
		if(with.withDeclarations.size() > 0)
			str += "\n";
		for(int i=0; i<sqls.size(); i++) {
			str += sqls.get(i).toString();
			if(i<sqls.size()-1)
				str += "\nUNION\n";
		}
		return str;
	}
	public String toStringWithSelect2() {
		String str = "";
		str += with.toString();
		if(with.withDeclarations.size() > 0)
			str += "\n";
		for(int i=0; i<sqls.size(); i++) {
			str += sqls.get(i).toStringWithSelect2();
			if(i<sqls.size()-1)
				str += "\nUNION\n";
		}
		return str;
	}
	public String toStringUnionAll() {
		String str = "";
		str += with.toString();
		if(with.withDeclarations.size() > 0)
			str += "\n";
		for(int i=0; i<sqls.size(); i++) {
			str += sqls.get(i).toString();
			if(i<sqls.size()-1)
				str += "\nUNION All\n";
		}
		return str;
	}
	public String toStringBenchmark() {
		String str = "";
		str += with.toStringBenchmark();
		if(with.withDeclarations.size() > 0)
			str += "\n";
		for(int i=0; i<sqls.size(); i++) {
			str += sqls.get(i).toStringBenchmark();
			if(i<sqls.size()-1)
				str += "\nUNION All\n";
		}
		return str;
	}
	public String toStringBenchmarkWithSelect2() {
		String str = "";
		str += with.toStringBenchmark();
		if(with.withDeclarations.size() > 0)
			str += "\n";
		for(int i=0; i<sqls.size(); i++) {
			str += sqls.get(i).toStringWithSelect2();
			if(i<sqls.size()-1)
				str += "\nUNION All\n";
		}
		return str;
	}
	public String toStringDebugging() {
		String str = "";
		str += "Name: " + name + "\n";
		str += with.toString();
		if(with.withDeclarations.size() > 0)
			str += "\n";
		for(int i=0; i<sqls.size(); i++) {
			str += sqls.get(i).toStringDebugging();
			if(i<sqls.size()-1)
				str += "\nUNION\n";
		}
		return str;
	}

	public String toViewString(String dbString) {
		String str = "";
		str += with.toString();
		if(with.withDeclarations.size() > 0)
			str += "\n";
		for(int i=0; i<sqls.size(); i++) {
			str += sqls.get(i).toViewString(dbString);
			if(i<sqls.size()-1)
				str += "\nUNION\n";
		}
		return str;
	}
}
