package edu.ucla.cs.db.prism.backend.SQL;
import java.util.Vector;

public class SQLUnionSet {
	public Vector<SQLUnion> sqlUnions;
	
	public SQLUnionSet () {
		sqlUnions = new Vector<SQLUnion>();
	}
	
	@Override
	public SQLUnionSet clone() {
		SQLUnionSet newSQLUnionSet = new SQLUnionSet();
		for(int i=0; i<sqlUnions.size(); i++) {
			SQLUnion newSQLUnion = this.sqlUnions.get(i).clone();
			newSQLUnionSet.sqlUnions.add(newSQLUnion);
		}
		return newSQLUnionSet;
	}
	
	public void setVersion(int version) {
		for(int i=0; i<sqlUnions.size(); i++) {
			sqlUnions.get(i).version = version;
		}
	}
	
	public void versionTag(int version,int minor_version) {
		for(int i=0; i<this.sqlUnions.size(); i++) {
			SQLUnion sqlUnion = this.sqlUnions.get(i);
			if(sqlUnion != null)
				sqlUnion.versionTag(version,minor_version);
		}
	}
	public void versionTag(String tag) {
		for(int i=0; i<this.sqlUnions.size(); i++) {
			SQLUnion sqlUnion = this.sqlUnions.get(i);
			if(sqlUnion != null)
				sqlUnion.versionTag(tag);
		}
	}
	public void versionUntag() {
		for(int i=0; i<this.sqlUnions.size(); i++) {
			SQLUnion sqlUnion = this.sqlUnions.get(i);
			if(sqlUnion != null)
				sqlUnion.versionUntag();
		}
	}
	
	// finds the first SQLUnion that has 'name'
	public SQLUnion getFirstSQLUnion(String name) {
		for(int i=0; i<sqlUnions.size(); i++)
			if(sqlUnions.get(i).name.equals(name))
				return sqlUnions.get(i);

		// not found
		return null;
	}
	
	public SQLUnion getFirstSQLUnion(String name, int version) {
		for(int i=0; i<sqlUnions.size(); i++)
			if(sqlUnions.get(i).name.equals(name) && 
					sqlUnions.get(i).version == version)
				return sqlUnions.get(i);

		// not found
		return null;
	}
	
	public void simplify() {
		for(int i=0; i<sqlUnions.size(); i++)
			sqlUnions.get(i).simplify();
	}
	
	public void removeTautologies() {
		for(int i=0; i<sqlUnions.size(); i++)
			sqlUnions.get(i).removeTautologies();
	}

	public void convertFunctionToREF(int targetVersion, int targetVersionMinor) {
		// CARLO FIX, add null check
		if(sqlUnions != null)
		for(int i=0; i<sqlUnions.size(); i++){
			SQLUnion s = sqlUnions.get(i);
			if(s != null)
				s.convertFunctionToREF(targetVersion, targetVersionMinor);
		}
	}	
	public void convertInequalityToREF(int targetVersion, int targetVersionMinor) {
		// CARLO FIX, add null check
		if(sqlUnions != null)
		for(int i=0; i<sqlUnions.size(); i++){
			SQLUnion s = sqlUnions.get(i);
			if(s != null)
				s.convertInequalityToREF(targetVersion, targetVersionMinor);
		}
	}
	public void convertREFToInequality(int targetVersion, int targetVersionMinor) {
		// CARLO FIX, add null check
		if(sqlUnions != null)
		for(int i=0; i<sqlUnions.size(); i++){
			SQLUnion s = sqlUnions.get(i);
			if(s != null)
				s.convertREFToInequality(targetVersion, targetVersionMinor);
		}
	}
	
	public void convertREFToFunction(int targetVersion, int targetVersionMinor) {
		// CARLO FIX, add null check
		if(sqlUnions != null)
		for(int i=0; i<sqlUnions.size(); i++){
			SQLUnion s = sqlUnions.get(i);
			if(s != null)
				s.convertREFToFunction(targetVersion, targetVersionMinor);
		}	
	}
	
	@Override
	public String toString() {
		String str = "";
		for(int i=0; i<sqlUnions.size(); i++) {
			str += "SQLUnion " + i + ":\n";
			str += sqlUnions.get(i).toString() + "\n\n";
		}
		return str;
	}
	public String toStringUnionAll() {
		String str = "";
		for(int i=0; i<sqlUnions.size(); i++) {
			str += "SQLUnion " + i + ":\n";
			str += sqlUnions.get(i).toStringUnionAll() + "\n\n";
		}
		return str;
	
	}	
	public String toStringDebugging() {
		String str = "";
		for(int i=0; i<sqlUnions.size(); i++) {
			str += "SQLUnion " + i + ":\n";
			str += sqlUnions.get(i).toStringDebugging() + "\n\n";
		}
		return str;
	}
	public String toStringBenchmark() {
		String str = "";
		for(int i=0; i<sqlUnions.size(); i++) {
			str += "SQLUnion " + i + ":\n";
			str += sqlUnions.get(i).toStringBenchmark() + "\n\n";
		}
		return str;
	
	}	
}
