package edu.ucla.cs.db.prism.backend.SQL;
import java.io.Serializable;
import java.util.Vector;

public class SelectClause implements Serializable {
	static final long serialVersionUID = 0;
	public Vector<SelectAttribute> selectAttributes;
	
	public SelectClause() {
		selectAttributes = new Vector<SelectAttribute>();
	}
	
	@Override
	public SelectClause clone() {
		SelectClause newSelectClause = new SelectClause();
		for(int i=0; i<this.selectAttributes.size(); i++) {
			newSelectClause.selectAttributes.add(this.selectAttributes.get(i).clone());
		}
		return newSelectClause;
	}
	
	public int selectAttributesSize() {
		return selectAttributes.size();
	}
	
	public void addSelectAttribute(SelectAttribute selectAttribute) {
		selectAttributes.add(selectAttribute);
	}

	public SelectAttribute getSelectAttribute(int index) {
		return selectAttributes.get(index);
	}
	public SelectAttribute get(int index) {
		return selectAttributes.get(index);
	}
	public SelectAttribute get(String outputAttributeName) {
		for(int i=0; i<selectAttributes.size(); i++) {
			SelectAttribute sa = selectAttributes.get(i);
			if(sa.outputAttributeName.equals(outputAttributeName))
				return sa;
		}
		return null;
	}

	
	@Override
	public String toString() {
		String result = "SELECT ";
		int i;
		
		// this will be removed when code is complete
		if(selectAttributes.isEmpty())
			return result;
		
		for(i=0; i<selectAttributes.size()-1; i++)
			result += selectAttributes.get(i).toString() + ", ";
		result += selectAttributes.get(i).toString();
		
		return result;
	}
	public String toStringBenchmark() {
		String result = "SELECT ";
		int i;
		
		// this will be removed when code is complete
		if(selectAttributes.isEmpty())
			return result;
		
		for(i=0; i<selectAttributes.size()-1; i++)
			result += selectAttributes.get(i).toStringBenchmark() + ", ";
		result += selectAttributes.get(i).toStringBenchmark();
		
		return result;
	}

	public String toViewString() {
		String result = "SELECT ";
		int i;
		
		// this will be removed when code is complete
		if(selectAttributes.isEmpty())
			return result;
		
		for(i=0; i<selectAttributes.size()-1; i++)
			result += selectAttributes.get(i).toViewString() + ", ";
		result += selectAttributes.get(i).toViewString();
		
		return result;
	}

	public Vector<SelectAttribute> getAttributesByAlias(String alias) {
		Vector<SelectAttribute> v = new Vector<SelectAttribute>();
		for(SelectAttribute sa:selectAttributes){
			
			if(alias.equals(sa.relationAlias)){
				v.add(sa);		
			}
			
		}
		return v;
	}
}
