package edu.ucla.cs.db.prism.backend.SQL;

import java.io.Serializable;
import java.util.Vector;

import edu.ucla.cs.db.prism.backend.smo.util.Term;

public class SelectClause2 implements Serializable {
	static final long serialVersionUID = 0;
	//public Vector<SelectAttribute> selectAttributes;
	private Vector<Term> terms = null;
	
	public SelectClause2() {
		terms = new Vector<Term>();	
	}
	public SelectClause2(Vector<Term> terms) {
		this.terms = terms;
	}
	
	@Override
	public SelectClause2 clone() {
		
		SelectClause2 newSelectClause = new SelectClause2();
		for(int i=0; i<this.terms.size(); i++) {
			newSelectClause.terms.add(this.terms.get(i).clone());
		}
		return newSelectClause;
	}
	
	public void addTerm(Term newterm) {
		terms.add(newterm);
	}
	public Vector<Term> getTerms() {
		return terms;		
	}
	public Term getTerm(int index) {
		return terms.get(index);
	}
	public int selectTermSize() {
		return terms.size();
	}
	@Override
	public String toString() {
		String temp="SELECT ";		
		for (int i=0; i<terms.size(); i++) {
			temp += terms.get(i).toString();}
		return temp;
	}
	
	/*
	public int selectAttributesSize() {
		return selectAttributes.size();
	}
	
	public void addSelectAttribute(SelectAttribute selectAttribute) {
		selectAttributes.add(selectAttribute);
	}

	public SelectAttribute getSelectAttribute(int index) {
		return selectAttributes.get(index);
	}
	public SelectAttribute get(int index) {
		return selectAttributes.get(index);
	}
	public SelectAttribute get(String outputAttributeName) {
		for(int i=0; i<selectAttributes.size(); i++) {
			SelectAttribute sa = selectAttributes.get(i);
			if(sa.outputAttributeName.equals(outputAttributeName))
				return sa;
		}
		return null;
	}

	
	public String toString() {
		String result = "SELECT ";
		int i;
		
		// this will be removed when code is complete
		if(selectAttributes.isEmpty())
			return result;
		
		for(i=0; i<selectAttributes.size()-1; i++)
			result += selectAttributes.get(i).toString() + ", ";
		result += selectAttributes.get(i).toString();
		
		return result;
	}
	public String toStringBenchmark() {
		String result = "SELECT ";
		int i;
		
		// this will be removed when code is complete
		if(selectAttributes.isEmpty())
			return result;
		
		for(i=0; i<selectAttributes.size()-1; i++)
			result += selectAttributes.get(i).toStringBenchmark() + ", ";
		result += selectAttributes.get(i).toStringBenchmark();
		
		return result;
	}

	public String toViewString() {
		String result = "SELECT ";
		int i;
		
		// this will be removed when code is complete
		if(selectAttributes.isEmpty())
			return result;
		
		for(i=0; i<selectAttributes.size()-1; i++)
			result += selectAttributes.get(i).toViewString() + ", ";
		result += selectAttributes.get(i).toViewString();
		
		return result;
	}
	*/
	
	
	// find out R.A from SQLXML SELECT clause
	public SelectClause getSelectClauseWithRelAttr() {
		// step 1: get all terms deep
		Vector<Term> deepTerms = new Vector<Term>();
		for(int i=0; i<terms.size(); i++)
			deepTerms.addAll(terms.get(i).getAllTermsDeep());

		// step 2: get unique rel.attr terms only
		Vector<Term> uniqueRATerms = new Vector<Term>();
		for(int i=0; i<deepTerms.size(); i++) {
			Term term = deepTerms.get(i);
			if(term.isRATerm() && !uniqueRATerms.contains(term))
				uniqueRATerms.add(term); 
		}

		// step 3: create a new select clause
		SelectClause select = new SelectClause();
		for(int i=0; i<uniqueRATerms.size(); i++) {
			SelectAttribute sa = new SelectAttribute();
			select.selectAttributes.add(sa);
			sa.relationAlias = uniqueRATerms.get(i).tableName;
			sa.attribute = uniqueRATerms.get(i).columnName;
		}
		return select;
	}
	
	public void replaceRelAttr(SelectClause selectClauseWithOrigRelAttr, 
			SelectClause selectClauseWithRewrittenRelAttr) throws SelectCauseException {
	
		// step 1: get all terms deep
		Vector<Term> deepTerms = new Vector<Term>();
		for(int i=0; i<terms.size(); i++)
			deepTerms.addAll(terms.get(i).getAllTermsDeep());

		// step 2: substitute RA term with the rewritten RA
		for(int i=0; i<deepTerms.size(); i++) {
			Term term = deepTerms.get(i);
			if(!term.isRATerm())
				continue;
			
			// step 2.1: get the index of R.A from the original select clause
			int index = -1;
			for(int j=0; j<selectClauseWithOrigRelAttr.selectAttributesSize(); j++) {
				SelectAttribute sa = 
					selectClauseWithOrigRelAttr.selectAttributes.get(j);
				if(sa.relationAlias.equals(term.tableName) &&
						sa.attribute.equals(term.columnName)) {
					index=j;
					break;
				}
			}
			if(index == -1) {
				System.err.println(term.toString() + " is not foundin selectClauseWithOrigRelAttr!");
				throw new SelectCauseException(term.toString() + " is not foundin selectClauseWithOrigRelAttr!");
				//System.exit(1);
			}
			
			// step 2.2: find the rewritten R'.A' using the index above
			SelectAttribute newSA = selectClauseWithRewrittenRelAttr.get(index);
			term.tableName = newSA.relationAlias;
			term.columnName = newSA.attribute;
		}
	}
}
