package edu.ucla.cs.db.prism.backend.SQL;
import java.util.Vector;

public class WithClause {
	public Vector<WithDeclaration> withDeclarations;
	
	public WithClause() {
		withDeclarations = new Vector<WithDeclaration>();
	}
	
	public WithDeclaration get(String tablename) {
		for(int i=0; i<withDeclarations.size(); i++)
			if(withDeclarations.get(i).tableSchema.getTableName().equals(tablename))
				return withDeclarations.get(i);
		return null;
	}
	
	@Override
	public WithClause clone() {
		WithClause newWithClause = new WithClause();
		if(this.withDeclarations != null) {
			newWithClause.withDeclarations = new Vector<WithDeclaration>();
			for(int i=0; i<this.withDeclarations.size(); i++)
				newWithClause.withDeclarations.add(this.withDeclarations.get(i).clone());
		}
		return newWithClause;
	}
	
	public void simplify() {
		for(int i=0; i<withDeclarations.size(); i++)
			withDeclarations.get(i).simplify();
	}
	
	@Override
	public String toString() {
		if(withDeclarations == null || withDeclarations.size()==0)
			return "";
		
		String str = "With ";
		for(int i=0; i<withDeclarations.size(); i++) {
			str += withDeclarations.get(i).toString();
			if(i<withDeclarations.size()-1)
				str += ",\n\n";
		}
		return str + "\n";
	}

	public String toStringBenchmark() {
		if(withDeclarations == null || withDeclarations.size()==0)
			return "";
		
		String str = "With ";
		for(int i=0; i<withDeclarations.size(); i++) {
			str += withDeclarations.get(i).toStringBenchmark();
			if(i<withDeclarations.size()-1)
				str += ",\n\n";
		}
		return str + "\n";
	}
}
