package edu.ucla.cs.db.prism.backend.SQL;

import edu.ucla.cs.db.prism.backend.schema.Table;

public class WithDeclaration {
	public Table tableSchema;
	public SQLUnion sqlUnion;
	
	@Override
	public WithDeclaration clone() {
		if(tableSchema == null || sqlUnion == null)
			return null;
		
		WithDeclaration newWithDeclaration = new WithDeclaration();
		newWithDeclaration.tableSchema = new Table(this.tableSchema);
		newWithDeclaration.sqlUnion = this.sqlUnion.clone();
		return newWithDeclaration;
	}
	
	public void simplify() {
		sqlUnion.simplify();
	}
	
	@Override
	public String toString() {
		String str = "";
		str += tableSchema.toString();
		if(str.charAt(str.length()-1) == '\n')
			str = str.substring(0, str.length()-1); // remove the last '\n'
		str += " AS\n";
		str += "(" + sqlUnion.toString() + ")";
		return str;
	}
	
	public String toStringBenchmark() {
		String str = "";
		str += tableSchema.toString();
		if(str.charAt(str.length()-1) == '\n')
			str = str.substring(0, str.length()-1); // remove the last '\n'
		str += " AS\n";
		str += "(" + sqlUnion.toStringBenchmark() + ")";
		return str;
	}
}
