package edu.ucla.cs.db.prism.backend.ded;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.StringTokenizer;
import java.util.Vector;

import edu.ucla.cs.db.prism.backend.util.db.DBUtil;

public class DEDSetHistoryLoader {
	boolean debug = true;
	Connection conn = null;
	String schemaName = null;
	
	public DEDSetHistoryLoader(Connection conn, String schemaName){
		this.conn = conn;	
		this.schemaName = schemaName;
	}
	
	public DEDSetHistory loadDEDSetHistoryFromDB(){
		
		DEDSetHistory dsh = new DEDSetHistory();
		
		String dedSetHistoryQuery = "SELECT d.DED_ID, d.DED_NAME, d.Source_Major, d.Source_Minor, d.Target_Major, d.Target_Minor, d.DED_TEXT,d.CHASE_FLAG, d.SOURCE_RELATIONS, d.TARGET_RELATIONS " +
									"FROM DED d " +
									"WHERE schema_name = '" + schemaName +"' " +
									"ORDER BY Source_Major, Source_Minor;";
		
		
		ResultSet dedSetHistoryList = DBUtil.executeSQLQuery(dedSetHistoryQuery,conn);
		
		DEDSet ds = null;
		
		String source_old_major = null;
		String source_major = null;
		String source_old_minor = null;
		String source_minor = null;
		
		try {
			while(dedSetHistoryList.next()){
				source_major = dedSetHistoryList.getString("Source_Major");
				source_minor = dedSetHistoryList.getString("Source_Minor");
				
				if(source_old_major == source_major && source_old_minor == source_minor)
					ds = new DEDSet();
				ds.add(new DED(dedSetHistoryList.getString("DED_ID"),
								dedSetHistoryList.getString("DED_NAME"),
								dedSetHistoryList.getBoolean("CHASE_FLAG"),
								parseTables(dedSetHistoryList.getString("SOURCE_RELATIONS")),
								parseTables(dedSetHistoryList.getString("TARGET_RELATIONS")),
								dedSetHistoryList.getString("DED_TEXT")));	
				dsh.add(ds);
				source_old_major = source_major;
				source_old_minor = source_minor;
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return dsh;
	}

	private Vector<String> parseTables(String string) {
		Vector<String> vec = new Vector<String>();
		StringTokenizer st = new StringTokenizer(string);
		while(st.hasMoreTokens())	
			vec.add(st.nextToken());
		
		return vec;
	}
	
}
