package edu.ucla.cs.db.prism.backend.ded;

import edu.ucla.cs.db.prism.backend.smo.util.Disjunctive;
import java.io.*;

public class QuantifiedDisjunctive implements Serializable {
	static final long serialVersionUID = 1;
	public QuantifierSet quantifiers; // this could be empty
	public Disjunctive disjunctive; // this could be empty
	
	public QuantifiedDisjunctive() {
		quantifiers = new QuantifierSet();
		disjunctive = new Disjunctive();
	}
	
	@Override
	public QuantifiedDisjunctive clone() {
		QuantifiedDisjunctive qc = new QuantifiedDisjunctive();
		qc.quantifiers = this.quantifiers.clone();
		qc.disjunctive = this.disjunctive.clone();
		return qc;
	}
	
	public void addAll(QuantifiedDisjunctive qc2) {
		this.quantifiers.addAll(qc2.quantifiers);
		this.disjunctive.addAll(qc2.disjunctive);
	}
	
	public int size() {
		return disjunctive.size();
	}
	
	@Override
	public String toString() {
		String str = "";
		if(quantifiers.size() > 0)
			str += quantifiers.toString() + "\n";
		if(disjunctive.size() > 0)
			str += disjunctive.toString() + "\n";
		return str;
	}
}
