package edu.ucla.cs.db.prism.backend.ded;
import java.util.Vector;

//import mapping.Mapping;
import java.io.*;

public class QuantifierSet implements Serializable {
	static final long serialVersionUID = 1;
	public Vector<Quantifier> quantifiers;
	public int sourceVariableIndex=0;
	
	public QuantifierSet() {
		quantifiers = new Vector<Quantifier>();
	}
	
	@Override
	public QuantifierSet clone() {
		QuantifierSet quantifierSet = new QuantifierSet();
		for(int i=0; i<this.quantifiers.size(); i++)
			quantifierSet.add(this.quantifiers.get(i).clone());
		quantifierSet.sourceVariableIndex = this.sourceVariableIndex;
		return quantifierSet;
	}
	
	public int size() {
		return quantifiers.size();
	}
	
	public boolean add(Quantifier quantifier) {
		return quantifiers.add(quantifier);
	}
	
	public void addFirst(Quantifier quantifier) {
		quantifiers.add(0,quantifier);
	}
	
	public boolean addAll(QuantifierSet quantifiers) {
		return this.quantifiers.addAll(quantifiers.quantifiers);
	}
	
	public Quantifier get(int index) {
		return quantifiers.get(index);
	}
	public Quantifier remove(int index) {
		return quantifiers.remove(index);
	}

	// search function
	public String getVariable(String relation) {
		for(int i=0; i<size(); i++)
			if(quantifiers.get(i).relation.equals(relation))
				return quantifiers.get(i).variable;

		return null; // if not found			
	}
	
	public boolean hasVariable(String variable) {
		for(int i=0; i<size(); i++)
			if(quantifiers.get(i).variable.equals(variable))
				return true;

		return false; // if not found			
	}
	
	@Override
	public String toString() {
		String str="";
		int numQuantifiersInLine = 4;
		
		for(int i=0; i<quantifiers.size(); i++) {
			str += quantifiers.get(i).toString();

			if(i < quantifiers.size()-1) {
				str += " ";
				if(i % numQuantifiersInLine == numQuantifiersInLine-1)
					str += "\n";
			}
		}
		return str;
	}
	
}
