package edu.ucla.cs.db.prism.backend.icmo;

import static org.junit.Assert.*;

import java.util.Vector;

import org.junit.Test;

import edu.ucla.cs.db.prism.backend.SQL.SQL;
import edu.ucla.cs.db.prism.backend.icmo.exceptions.AddPrimaryKeyException;
import edu.ucla.cs.db.prism.backend.schema.integrityconstraints.ForeignKey;
import edu.ucla.cs.db.prism.backend.schema.integrityconstraints.ICSchema;
import edu.ucla.cs.db.prism.backend.schema.integrityconstraints.ICTable;
import edu.ucla.cs.db.prism.backend.schema.integrityconstraints.PrimaryKey;
import edu.ucla.cs.db.prism.backend.schema.integrityconstraints.exceptions.IntegrityConstraintsExistsException;

public class AddPrimaryKeyTest {
	ICSchema testschema;
	public void init(){
		
	    testschema = new ICSchema(0, 0, "testschema","", "","","", "0",null,null);
		
		ICTable test1 = new ICTable("test1");
		test1.addColumn("k1");
		test1.addColumn("k2");
		test1.addColumn("a");
		test1.addColumn("b");
		test1.addColumn("c");
		
		ICTable test2 = new ICTable("test2");
		test2.addColumn("k1");
		test2.addColumn("d");
		test2.addColumn("e");
		test2.addColumn("f");
		
		
		testschema.addTable(test1);
		testschema.addTable(test2);
		
	}
	
	@Test
	public final void testRewriteQuery() {
		init();
		String query = "SELECT t.c FROM test1 t WHERE t.b=\"1\" AND NOT EXISTS (SELECT t2.c FROM test1 t2)";
		query = "SELECT t1.k1 FROM test1 t1, test2 t2 WHERE t1.b=\"1\" AND t1.k1 = t2.k1";
				
		Vector<String> v = new Vector<String>();
		v.add("k1");
		v.add("k2");
		
		AddPrimaryKey a;
		try {
			System.out.println("INPUT QUERY:\n" + query);
			
			a = new AddPrimaryKey("pk1", 0,0,1,0, "test1",v,false,true, false);
			System.out.println("\nEVOLUTION STEP:\n" + a.toString());
			System.out.println("OUTPUT QUERY:\n" + a.rewriteQuery(query, testschema));
			
		} catch (AddPrimaryKeyException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		fail("Not yet implemented"); // TODO
	}

}
