package edu.ucla.cs.db.prism.backend.icmo;

import java.util.Vector;

import edu.ucla.cs.db.prism.backend.exception.SchemaErrorException;
import edu.ucla.cs.db.prism.backend.icmo.exceptions.AddPrimaryKeyException;
import edu.ucla.cs.db.prism.backend.schema.Schema;
import edu.ucla.cs.db.prism.backend.schema.integrityconstraints.ICSchema;
import edu.ucla.cs.db.prism.backend.schema.integrityconstraints.PrimaryKey;
import edu.ucla.cs.db.prism.backend.smo.util.SMOSequence;

public class DropPrimaryKey extends ICMOImpl{

	public Vector<String> columns = null;
	/**
	 * 
	 * @param tableName
	 * @param columns
	 *	
	 */
	public DropPrimaryKey(String tableName, Vector<String> columns) {
		super();
		this.tableName = tableName;
		this.columns = columns;
	}
	
	public DropPrimaryKey(String id,int i, int j, int k, int l, String tableName) {
		super(id,i,j,k,l);
		this.tableName = tableName;
	}

	public DropPrimaryKey(String dropPrimaryKey) {
		// TODO Auto-generated constructor stub
		super(dropPrimaryKey);
	}

	public Vector<String> getColumns() {
		return columns;
	}

	public void setColumns(Vector<String> columns) {
		this.columns = columns;
	}

	@Override
	public SMOSequence getBestCandidateInverses(Schema inputSchema)
			throws SchemaErrorException, AddPrimaryKeyException {
		if(!(inputSchema instanceof ICSchema))
			throw new SchemaErrorException("You are trying to add constraints to a non-ic-aware Schema object");
		
		PrimaryKey vvc = ((ICSchema)inputSchema).getTable(this.getTableName()).getPrimaryKey();
		if(!vvc.getId().equals(this.id))
			throw new AddPrimaryKeyException("You are trying to drop an unexisitng PrimaryKey");
		
		AddPrimaryKey dvc = new AddPrimaryKey(this.id,this.tableName,vvc.getFields(),ICMOInterface.CHECK);
		dvc.setSourceMajor(this.getTargetMajor());
		dvc.setSourceMinor(this.getTargetMinor());
		dvc.setTargetMajor(this.getSourceMajor());
		dvc.setTargetMinor(this.getSourceMinor());

		ICMOSMOSequence iss = new ICMOSMOSequence();
		iss.sourceVersion = this.getTargetMajor();
		iss.targetVersion = this.getSourceMajor();
		
		iss.getMos().add(dvc);
		return iss;
	}
	
	@Override
	public String toString(){
		
		return "ALTER TABLE " +tableName + " DROP PRIMARY KEY \"" + this.id + "\"\n";
		
	}

	@Override
	public boolean isInfPreserving(Schema currentSchema) {
		return true;
	}

	@Override
	public String getOperatorType() {
		return ICMOInterface.DROP_PRIMARY_KEY;
	}


	

	
}
