package edu.ucla.cs.db.prism.backend.icmo;

import java.io.StringReader;

import edu.ucla.cs.db.prism.backend.parser.parser.ParseException;
import edu.ucla.cs.db.prism.backend.parser.parser.PrimaRParser;
import edu.ucla.cs.db.prism.backend.parser.parser.TokenMgrError;
import edu.ucla.cs.db.prism.backend.parser.syntaxtree.Icmo;
import edu.ucla.cs.db.prism.backend.parser.syntaxtree.Smo;
import edu.ucla.cs.db.prism.backend.restructure.IcmoRestructure;
import edu.ucla.cs.db.prism.backend.restructure.SmoRestructure;
import edu.ucla.cs.db.prism.backend.smo.exception.SMOParsingErrorException;

public class MOFactory {

	public static MOImpl createMOFromString(String string) throws SMOParsingErrorException {
		StringReader input = null;
		input = new StringReader(string);

		PrimaRParser parser = new PrimaRParser(input);
		Icmo icmo = null;
		Smo smo = null;
		
		MOImpl parsedmo = null;
		try {
			
			if(string.toUpperCase().startsWith("ALTER")){
					icmo = parser.Icmo();
				parsedmo = IcmoRestructure.restructure(icmo);
			}else{
				smo = parser.Smo();
				parsedmo = SmoRestructure.restructure(smo);			
			}
		} catch (ParseException e) {
			//e.printStackTrace();
			throw new SMOParsingErrorException("syntax error, check your syntax");
		} catch (TokenMgrError t){
			throw new SMOParsingErrorException("syntax error, unrecognized token");
		}
		
			return parsedmo;
	
	}
}