package edu.ucla.cs.db.prism.backend.icmo;

import edu.ucla.cs.db.prism.backend.ded.DEDSet;
import edu.ucla.cs.db.prism.backend.exception.SchemaErrorException;
import edu.ucla.cs.db.prism.backend.icmo.exceptions.AddForeignKeyException;
import edu.ucla.cs.db.prism.backend.icmo.exceptions.AddPrimaryKeyException;
import edu.ucla.cs.db.prism.backend.schema.Schema;
import edu.ucla.cs.db.prism.backend.schema.integrityconstraints.ComplexValueCosntraintNotImplementedException;
import edu.ucla.cs.db.prism.backend.schema.integrityconstraints.exceptions.ExpressionParsignErrorException;
import edu.ucla.cs.db.prism.backend.smo.exception.NoTableInSchemaException;
import edu.ucla.cs.db.prism.backend.smo.exception.noColumnsMatchInfPres;
import edu.ucla.cs.db.prism.backend.smo.exception.noCommonColumnInfPres;
import edu.ucla.cs.db.prism.backend.smo.util.SMOSequence;

public abstract class MOImpl implements MOInterface {

	
	public SMOSequence assignedInverse = null;
	
	public abstract DEDSet getAllDEDs(Schema curSchema) throws ExpressionParsignErrorException, ComplexValueCosntraintNotImplementedException, SchemaErrorException;

	public abstract SMOSequence getBestCandidateInverses(Schema inputSchema) throws SchemaErrorException, AddPrimaryKeyException, DropForeignKeyException, AddForeignKeyException;

	public abstract boolean isInfPreserving(Schema currentSchema) throws NoTableInSchemaException,noCommonColumnInfPres,noColumnsMatchInfPres;

	public abstract String getOperatorType();

	public abstract boolean isRedundant();

	public abstract String toMetadataString();

	public abstract void setId(int i);

	public abstract boolean isComplete();

	public abstract String getSQLDDL(Schema tsch, String schemaName);

	public void setAssignedInverse(ICMOSMOSequence ics ){
		
		assignedInverse = ics;
	}
	
	public SMOSequence getAssignedInverse(){
		
		return assignedInverse;
	}
	
	
}
