package edu.ucla.cs.db.prism.backend.oldtestmain;

import it.polimi.elet.cautils.configurator.CACmdLineParser;
import it.polimi.elet.cautils.configurator.CAConfiguration;

import java.sql.Connection;

import org.apache.log4j.Logger;

import edu.ucla.cs.db.prism.backend.smo.util.SMOSequenceHistory;
import edu.ucla.cs.db.prism.backend.smo.util.SMOSequenceHistoryLoader;
import edu.ucla.cs.db.prism.backend.util.Log4JHelper;
import edu.ucla.cs.db.prism.backend.util.db.DBUtil;

public class MainSMOLoad {
	
	//STATIC LOGGER
	static Logger logger = Logger.getLogger(MainSMOLoad.class);
	
	public static void main(String[] args) {
		 
         //LOG4J SET UP
         Log4JHelper.log4JSetup(logger);
        
        
		//Use CAConfigurator to load configuration from shell or xml-configuration file (-c inputfile)
		 CACmdLineParser par = null;
	 	 try {
			par = CACmdLineParser.getInstance();
		 } catch (InstantiationException e) {
			e.printStackTrace();
		 }
		//List here all the interesting parameters
		 par.addStringParameter('h',"host");	
		 par.addStringParameter('u',"dburl");
		 par.addStringParameter('m',"metadbname");	
		 par.addStringParameter('u',"username");
		 par.addStringParameter('p',"password");
		 par.addStringParameter('l',"logfile");
		 
		//parse them all 
		 CAConfiguration conf = par.parse(args);
		 
		//read the parameter you are interested in 
		 String host = (String) conf.getParameterValue("host");
		 String dburl = (String) conf.getParameterValue("dburl");
		 String metadbname = (String) conf.getParameterValue("metadbname");
		 String dbname = (String) conf.getParameterValue("dbname");
		 String username = (String) conf.getParameterValue("username");
		 String password = (String) conf.getParameterValue("password");
		 
		//use them
		 System.out.println("PRIM is about to be executed with the follwing parameters:");
		 System.out.println("  - host: " + host);		
		 System.out.println("  - user: " + username);
		 System.out.println("  - pass: " + password);
		 System.out.println("  - metadb: " + metadbname);
		 
		// MySQL DRIVER LOADING 
        try {
            Class.forName("com.mysql.jdbc.Driver").newInstance();
        } catch (Exception ex) { ex.printStackTrace();}
	 

         Connection conn = DBUtil.connect(dburl,metadbname,username,password);
		
         // example of usage of the logger
         logger.info("Connected to the DB:" + dburl +" " +metadbname+" " +username);
		 
         SMOSequenceHistoryLoader sshl = new SMOSequenceHistoryLoader(conn,dbname);
         SMOSequenceHistory ssh = sshl.loadSMOSequenceHistoryFromDB();
         
         System.out.println(ssh.toString());
         
         //store back to the DB the same sequence, generating new IDS
		// sshl.storeSMOSequenceHistoryFromDB(ssh,true);
		 
	}
	

	
}
