package edu.ucla.cs.db.prism.backend.oldtestmain;

import it.polimi.elet.cautils.configurator.CACmdLineParser;
import it.polimi.elet.cautils.configurator.CAConfiguration;

import java.sql.Connection;
import java.util.Iterator;
import java.util.Vector;

import org.apache.log4j.Logger;

import edu.ucla.cs.db.prism.backend.schema.*;
import edu.ucla.cs.db.prism.backend.smo.util.*;
import edu.ucla.cs.db.prism.backend.util.Log4JHelper;
import edu.ucla.cs.db.prism.backend.util.db.DBUtil;
import edu.ucla.cs.db.prism.gui.server.DBLoader;

public class MainSQLandViewTest {

	//STATIC LOGGER
	static Logger logger = Logger.getLogger(DBLoader.class);
	
	
	public static void main(String[] args) {
		
		  //LOG4J SET UP
        Log4JHelper.log4JSetup(logger);
       
		//Use CAConfigurator to load configuration from shell or xml-configuration file (-c inputfile)
		 CACmdLineParser par = null;
	 	 try {
			par = CACmdLineParser.getInstance();
		 } catch (InstantiationException e) {
			e.printStackTrace();
		 }
		 System.out.println(par.toString());
		//List here all the interesting parameters
		 par.addStringParameter('h',"host");	
		 par.addStringParameter('u',"dburl");
		 par.addStringParameter('m',"metadbname");	
	     par.addStringParameter('d',"dbname");
		 par.addStringParameter('u',"username");
		 par.addStringParameter('p',"password");
		 par.addStringParameter('l',"logfile");
		 par.addStringParameter('l',"viewfile");
		 
		//parse them all 
		 CAConfiguration conf = par.parse(args);
		 
		//read the parameter you are interested in 
		 String host = (String) conf.getParameterValue("host");
		 String dburl = (String) conf.getParameterValue("dburl");
		 String metadbname = (String) conf.getParameterValue("metadbname");
		 String dbname = (String) conf.getParameterValue("dbname");
		 String username = (String) conf.getParameterValue("username");
		 String password = (String) conf.getParameterValue("password");
		 String viewfile = (String) conf.getParameterValue("viewfile");
		//use them
		 System.out.println("PRIM SMO to VIEW from DB  : ");
		 
		// MySQL DRIVER LOADING 
       try {
           Class.forName("com.mysql.jdbc.Driver").newInstance();
       } catch (Exception ex) { ex.printStackTrace();}
	 
       System.out.println(dburl);
       System.out.println(metadbname);
       System.out.println(username);
       System.out.println(password);
        Connection conn = DBUtil.connect(dburl,metadbname,username,password);
		    
        // example of usage of the logger
        logger.info("Connected to the DB:" + dburl +" " +metadbname+" " +username);
		 
		 SchemaHistoryLoader shl = new SchemaHistoryLoader(conn,dbname);
		 SchemaHistory schemaHistory = shl.loadSchemaHistoryFromDB(false);

		 logger.info("Schema Loaded");
		
		 SMOSequenceHistoryLoader sshl = new SMOSequenceHistoryLoader(conn,dbname);
	     SMOSequenceHistory ssh = sshl.loadSMOSequenceHistoryFromDB(true);
		 
	     
	     //System.out.println(ssh);
	     //System.out.println(schemaHistory.schemas.firstElement());
	     
	     // invoke the generation of the data migration script...
	     Vector<String> dataMigration = ssh.getSQLDDL(schemaHistory.schemas.firstElement(),dbname);
	
		 Iterator<String> vit = dataMigration.iterator();
		  while(vit.hasNext()){
			     System.out.println(vit.next());
		  }
		       
	     
	     /* 
	     Vector<String> views  = ssh.getSQLViewsAll(schemaHistory.schemas.firstElement().clone(),dbname);	
	     
	     System.out.println("GENERATED: " + views.size() + " VIEWS");
	     
	     try{
	    	    // Create file 
	    	    FileWriter fstream = new FileWriter(viewfile);
	    	        BufferedWriter out = new BufferedWriter(fstream);
	    
	    	        
	    		     Iterator<String> vit = views.iterator();
	    		     while(vit.hasNext()){
	    		    	 out.write(vit.next() + "\n");
	    		     }
	    		       
	    	    //Close the output stream
	    	    out.close();
	    	    }catch (Exception e){//Catch exception if any
	    	      System.err.println("Error: " + e.getMessage());
	    	    }
	     
	     */
	}
	
}
