//
// Generated by JTB 1.3.2
//

package edu.ucla.cs.db.prism.backend.parser.visitor;
import edu.ucla.cs.db.prism.backend.parser.syntaxtree.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
public class GJVoidDepthFirst<A> implements GJVoidVisitor<A> {
   //
   // Auto class visitors--probably don't need to be overridden.
   //
   public void visit(NodeList n, A argu) {
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
   }

   public void visit(NodeListOptional n, A argu) {
      if ( n.present() ) {
         int _count=0;
         for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
            e.nextElement().accept(this,argu);
            _count++;
         }
      }
   }

   public void visit(NodeOptional n, A argu) {
      if ( n.present() )
         n.node.accept(this,argu);
   }

   public void visit(NodeSequence n, A argu) {
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
   }

   public void visit(NodeToken n, A argu) {}

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> StatementList()
    */
   public void visit(PrimaRScript n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> ( Statement() ";" )+
    */
   public void visit(StatementList n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> Declaration()
    *       | Command()
    */
   public void visit(Statement n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> SchemaDeclaration()
    *       | VersionStartTimeDeclaration()
    *       | SmoDeclaration()
    *       | SQLQueryDeclaration()
    *       | XQueryDeclaration()
    */
   public void visit(Declaration n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> ComputeCommand()
    *       | PrintCommand()
    */
   public void visit(Command n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> <SCHEMA>
    * f1 -> <V>
    * f2 -> "("
    * f3 -> <INTEGER_VALUE>
    * f4 -> ")"
    * f5 -> ":="
    * f6 -> "{"
    * f7 -> RelationList()
    * f8 -> "}"
    */
   public void visit(SchemaDeclaration n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      n.f7.accept(this, argu);
      n.f8.accept(this, argu);
   }

   /**
    * f0 -> ( Relation() ";" )+
    */
   public void visit(RelationList n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> <ID>
    * f1 -> "("
    * f2 -> AttrList()
    * f3 -> [ <COMMA> <PRIMARY> <KEY> "(" AttrList() ")" ]
    * f4 -> ")"
    */
   public void visit(Relation n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
   }

   /**
    * f0 -> <ID>
    * f1 -> ( <COMMA> <ID> )*
    */
   public void visit(AttrList n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> <VERSIONSTARTTIME>
    * f1 -> <V>
    * f2 -> "("
    * f3 -> <INTEGER_VALUE>
    * f4 -> ")"
    * f5 -> ":="
    * f6 -> <STRING_VALUE>
    */
   public void visit(VersionStartTimeDeclaration n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
   }

   /**
    * f0 -> <SMO>
    * f1 -> <V>
    * f2 -> "("
    * f3 -> <INTEGER_VALUE>
    * f4 -> <COMMA>
    * f5 -> <INTEGER_VALUE>
    * f6 -> ")"
    * f7 -> ":="
    * f8 -> "{"
    * f9 -> SmoList()
    * f10 -> "}"
    */
   public void visit(SmoDeclaration n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      n.f7.accept(this, argu);
      n.f8.accept(this, argu);
      n.f9.accept(this, argu);
      n.f10.accept(this, argu);
   }

   /**
    * f0 -> ( Smo() ";" )+
    */
   public void visit(SmoList n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> <CREATE> <TABLE> <ID> [ <LPAREN> [ column_list() ] <RPAREN> ]
    *       | <DROP> <TABLE> <ID>
    *       | <RENAME> <TABLE> <ID> <INTO> <ID>
    *       | <COPY> <TABLE> <ID> <INTO> <ID>
    *       | <PARTITION> <TABLE> <ID> <INTO> <ID> <WITH> expression() "," <ID> <WITH> expression()
    *       | <MERGE> <TABLE> <ID> [ <WITH> expression() ] "," <ID> [ <WITH> expression() ] <INTO> <ID>
    *       | <ADD> <COLUMN> <ID> [ column_type() ] [ <AS> ( final_value() | <NULL> | function_call() ) ] <INTO> <ID>
    *       | <DROP> <COLUMN> <ID> <FROM> <ID>
    *       | <RENAME> <COLUMN> <ID> <IN> <ID> <TO> <ID>
    *       | <JOIN> <TABLE> <ID> "," <ID> <INTO> <ID> [ <WHERE> expression() ]
    *       | <DECOMPOSE> <TABLE> <ID> <INTO> <ID> <LPAREN> id_list() <RPAREN> "," <ID> <LPAREN> id_list() <RPAREN>
    *       | <NOP>
    */
   public void visit(Smo n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> <QUERY>
    * f1 -> <ID>
    * f2 -> ":="
    * f3 -> sql_union()
    */
   public void visit(SQLQueryDeclaration n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
   }

   /**
    * f0 -> ( <LPAREN> sql_union() <RPAREN> | sql() )
    * f1 -> [ <UNION> sql_union() ]
    */
   public void visit(sql_union n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> <SELECT>
    * f1 -> field_values()
    * f2 -> <FROM>
    * f3 -> bindings()
    * f4 -> [ <WHERE> expression() ]
    */
   public void visit(sql n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
   }

   /**
    * f0 -> field_value()
    * f1 -> [ <COMMA> field_values() ]
    */
   public void visit(field_values n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> [ <ID> <EQUAL> ]
    * f1 -> [ expression() | atomic_aggregate() <LPAREN> expression() <RPAREN> ]
    */
   public void visit(field_value n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> <SOME>
    *       | <ALL>
    *       | <MAX>
    *       | <MIN>
    *       | <SUM>
    *       | <PROD>
    *       | <CONCAT>
    */
   public void visit(atomic_aggregate n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> expression()
    * f1 -> <ID>
    * f2 -> [ <COMMA> bindings() ]
    */
   public void visit(bindings n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * f0 -> <COMPUTE>
    * f1 -> <ID>
    * f2 -> ":="
    * f3 -> <TRANSLATE>
    * f4 -> <ID>
    * f5 -> <FROM>
    * f6 -> <V>
    * f7 -> "("
    * f8 -> <INTEGER_VALUE>
    * f9 -> ")"
    * f10 -> ( <TO> <V> "[" IntegerValueList() "]" )?
    */
   public void visit(ComputeCommand n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      n.f7.accept(this, argu);
      n.f8.accept(this, argu);
      n.f9.accept(this, argu);
      n.f10.accept(this, argu);
   }

   /**
    * f0 -> <INTEGER_VALUE>
    * f1 -> [ <COMMA> IntegerValueList() ]
    */
   public void visit(IntegerValueList n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> <PRINT>
    * f1 -> <ID>
    */
   public void visit(PrintCommand n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> arith_expOr()
    */
   public void visit(expression n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> arith_expAnd()
    * f1 -> [ <OR> arith_expOr() ]
    */
   public void visit(arith_expOr n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> relational_exp() [ <AND> arith_expAnd() ]
    *       | "(" arith_expOr() ")" [ <AND> arith_expAnd() ]
    */
   public void visit(arith_expAnd n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> arith_unary()
    * f1 -> ( <EQUAL> arith_unary() | <NOTEQ> arith_unary() | <LESS> arith_unary() | <GREAT> arith_unary() | <NOMORE> arith_unary() | <NOLESS> arith_unary() )?
    */
   public void visit(relational_exp n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> <MINUS> arith_element()
    *       | arith_element()
    */
   public void visit(arith_unary n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> final_value()
    *       | non_final_value()
    */
   public void visit(arith_element n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> <INTEGER_VALUE>
    *       | <STRING_VALUE>
    */
   public void visit(final_value n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> <ID> [ <DOT> <ID> ]
    *       | <NULL>
    *       | <MID>
    */
   public void visit(non_final_value n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> ( <ID> | atomic_aggregate() )
    * f1 -> <LPAREN>
    * f2 -> [ id_list() ]
    * f3 -> <RPAREN>
    */
   public void visit(function_call n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
   }

   /**
    * f0 -> <XQUERY>
    * f1 -> <ID>
    * f2 -> ":="
    * f3 -> xquery()
    */
   public void visit(XQueryDeclaration n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
   }

   /**
    * f0 -> <MID>
    *       | <LESS> <ID> <GREAT> <LBRACE> xquery() ( <COMMA> xquery() )* <RBRACE> <LESS> <DIV> <ID> <GREAT>
    *       | <FOR> one_for_clause() ( <COMMA> one_for_clause() )* ( <WHERE> expression() )? <RETURN> xquery()
    */
   public void visit(xquery n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> <MID>
    * f1 -> <IN>
    * f2 -> path()
    */
   public void visit(one_for_clause n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * f0 -> ( ( <DOCUMENT> <LPAREN> <STRING_VALUE> <RPAREN> ) | <MID> )
    * f1 -> <DIV>
    * f2 -> <ID>
    */
   public void visit(path n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * f0 -> <ID>
    * f1 -> ( <COMMA> <ID> )*
    */
   public void visit(id_list n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> <ALTER> <TABLE> <ID> <ADD> <PRIMARY> <KEY> [ <ID> | <STRING_VALUE> ] [ <LPAREN> [ column_list() ] <RPAREN> ] [ <CHECK> | <ENFORCE> | <DECLARE> ]
    *       | <ALTER> <TABLE> <ID> <ADD> <FOREIGN> <KEY> [ <ID> | <STRING_VALUE> ] [ <LPAREN> [ column_list() ] <RPAREN> ] <REFERENCES> <ID> [ <LPAREN> [ column_list() ] <RPAREN> ] [ <CHECK> | <ENFORCE> | <DECLARE> ]
    *       | <ALTER> <TABLE> <ID> <ADD> <VALUE> <CONSTRAINT> [ <ID> | <STRING_VALUE> ] expression() [ <CHECK> | <ENFORCE> | <DECLARE> ]
    *       | <ALTER> <TABLE> <ID> <DROP> [ <PRIMARY> <KEY> | <FOREIGN> <KEY> | <VALUE> <CONSTRAINT> ] [ <ID> | <STRING_VALUE> ]
    */
   public void visit(Icmo n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> <ID>
    * f1 -> [ column_type() ]
    * f2 -> [ <COMMA> column_list() ]
    */
   public void visit(column_list n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * f0 -> ( <ID> )+
    * f1 -> [ <LPAREN> <INTEGER_VALUE> <RPAREN> ]
    * f2 -> ( <ID> )*
    */
   public void visit(column_type n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

}
