package edu.ucla.cs.db.prism.backend.restructure;
import java.util.Vector;

import edu.ucla.cs.db.prism.backend.parser.syntaxtree.ComputeCommand;
import edu.ucla.cs.db.prism.backend.parser.syntaxtree.IntegerValueList;
import edu.ucla.cs.db.prism.backend.parser.syntaxtree.NodeSequence;
import edu.ucla.cs.db.prism.backend.schema.SchemaHistory;
import edu.ucla.cs.db.prism.backend.smo.util.SMOSequenceHistory;

public class ComputeCommandRestructure {
	
	static public Vector<Integer> getSourceSchemaVersions(ComputeCommand n, SchemaHistory schemaHistory, SMOSequenceHistory smoSequenceHistory) throws CommandRestructureException {
	
		Vector<Integer> sourceVersions = null;
		if(n.f10.present()) {
			NodeSequence n2 = (NodeSequence)n.f10.node;
			sourceVersions = restructure((IntegerValueList)n2.nodes.get(3));
			for(int i=0; i<sourceVersions.size(); i++)
				if(schemaHistory.getSchemaByVersion(sourceVersions.get(i),0) == null) {
					System.err.println("Error: query target version " +
							sourceVersions.get(i) + " is undefined");
					throw new CommandRestructureException("Error: query target version " +
							sourceVersions.get(i) + " is undefined");
					//System.exit(0);
				}
		}
		else // default 
			sourceVersions = smoSequenceHistory.getAllSourceVersions();
		
		sort(sourceVersions);
		return sourceVersions;
	}

	static public int getInputQuerySchemaVersion(ComputeCommand n) {
		return Integer.parseInt(n.f8.tokenImage);
	}

	static public String getInputQueryName(ComputeCommand n) {
		return n.f4.tokenImage;
	}
	

	static private Vector<Integer> restructure(IntegerValueList n) {
		Vector<Integer> numbers = new Vector<Integer>();
		
		numbers.add(new Integer(n.f0.tokenImage));
		if(n.f1.present()) {
			NodeSequence n2 = (NodeSequence)n.f1.node;
			Vector<Integer> numbers2 = restructure((IntegerValueList)n2.nodes.get(1));
			numbers.addAll(numbers2);
		}
		return numbers;
	}
	
	static private void sort(Vector<Integer> numbers) {
		// sort
		for(int i=0; i<numbers.size(); i++) {
			for(int j=i+1; j<numbers.size(); j++) {
				if(numbers.get(i).intValue() >
				numbers.get(j).intValue()) {
					// swap (j>i)
					Integer tempj = numbers.remove(j);
					Integer tempi = numbers.remove(i);
					numbers.add(i, tempj);
					numbers.add(j, tempi);
				}
			}
		}
	}
}
