package edu.ucla.cs.db.prism.backend.restructure;

import java.util.*;

import edu.ucla.cs.db.prism.backend.parser.syntaxtree.AttrList;
import edu.ucla.cs.db.prism.backend.parser.syntaxtree.Node;
import edu.ucla.cs.db.prism.backend.parser.syntaxtree.NodeListOptional;
import edu.ucla.cs.db.prism.backend.parser.syntaxtree.NodeSequence;
import edu.ucla.cs.db.prism.backend.parser.syntaxtree.NodeToken;
import edu.ucla.cs.db.prism.backend.parser.syntaxtree.Relation;
import edu.ucla.cs.db.prism.backend.parser.syntaxtree.RelationList;
import edu.ucla.cs.db.prism.backend.parser.syntaxtree.SchemaDeclaration;
import edu.ucla.cs.db.prism.backend.schema.Schema;
import edu.ucla.cs.db.prism.backend.schema.Table;

public class SchemaRestructure {

	public static Schema restructure(SchemaDeclaration n) {
		Schema schema = restructure(n.f7);
		schema.versionID = Integer.parseInt(n.f3.tokenImage);
		return schema;
	}
	
	public static Schema restructure(RelationList n) {
		Schema schema = new Schema();
		
		for(int i=0; i < n.f0.nodes.size(); i++) {
			Node n2 = ((NodeSequence) (n.f0.nodes.get(i))).elementAt(0);
			Relation relationNode = (Relation) n2;
			
			Table table = new Table(relationNode.f0.tokenImage);
			AttrList attrList = relationNode.f2;
			Vector<String> columns = restructure(attrList);
			for(int j=0; j<columns.size(); j++)
				table.addColumn(columns.get(j));
			// primary keys
			if(relationNode.f3.present()) {
				NodeSequence n3 = (NodeSequence)relationNode.f3.node;
				table.setPrimaryKeys(restructure((AttrList)n3.nodes.get(4)));
			}
			else
				table.setPrimaryKeys(null);
			
			schema.addTable(table);
		}
		return schema;
	}
	
	public static Vector<String> restructure(AttrList attrList) {
		Vector<String> attributes = new Vector<String>();
		attributes.add(attrList.f0.tokenImage); // first attribute
		NodeListOptional n3 = attrList.f1;
		if( n3.present() )						// rest attributes (if any)
			for( Enumeration<Node> e = n3.elements(); e.hasMoreElements(); )
				attributes.add(((NodeToken)((NodeSequence)e.nextElement()).nodes.get(1)).tokenImage);
		return attributes;
	}
}
