package edu.ucla.cs.db.prism.backend.rewrite;

import edu.ucla.cs.db.prism.backend.SQL.SQLUnionSet;
import edu.ucla.cs.db.prism.backend.ded.DEDSetHistory;
import edu.ucla.cs.db.prism.backend.exception.ErrorRewritingException;
import edu.ucla.cs.db.prism.backend.exception.RewritingOptimizationException;
import edu.ucla.cs.db.prism.backend.icmo.AddPrimaryKey;
import edu.ucla.cs.db.prism.backend.schema.integrityconstraints.ICSchema;
import edu.ucla.cs.db.prism.backend.schema.integrityconstraints.ICSchemaHistory;

public class AddPkRewriteEngine extends ICPrimRewriteEngine {

	AddPrimaryKey icmo = null;
	ICSchema schema = null;
	
	public AddPkRewriteEngine(ICSchemaHistory schemaHistory, DEDSetHistory dedSetHistory) throws ErrorRewritingException {
		super(schemaHistory, dedSetHistory);
	}
	
	public AddPkRewriteEngine(AddPrimaryKey icmo, ICSchema schema) throws ErrorRewritingException{
		super();
		this.icmo = icmo;
		this.schema = schema;
	}

	public String rewriteWithNegationAndICMO(String inputSQL, int sourceVersion, int sourceMinorVersion, int targetVersion, int targetMinorVersion) throws ErrorRewritingException {

			if(schema.versionID!=sourceVersion || schema.minorVersionID!=sourceMinorVersion)
				throw new ErrorRewritingException("Wrong schema version request for rewriting");
		
			return icmo.rewriteQuery(inputSQL, schema);
		
	}
	
	public String rewriteWithNegationAndICMO(String inputSQL) throws ErrorRewritingException{
		return icmo.rewriteQuery(inputSQL, schema);
	}

}
