package edu.ucla.cs.db.prism.backend.rewrite;

import java.io.Writer;
import java.util.HashMap;
import java.util.Timer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.shiftone.cache.Cache;
import org.shiftone.cache.CacheConfiguration;
import org.shiftone.cache.CacheFactory;
import org.shiftone.cache.ConfigurationException;
import org.shiftone.cache.policy.lfu.LfuCacheFactory;

import edu.ucla.cs.db.prism.backend.util.Stopwatch;

public class RewritingCacheManager {

	
	Cache cache = null;	
	
	public RewritingCacheManager(){
		CacheFactory factory = new LfuCacheFactory();
		cache = factory.newInstance("qwer",1000000,2000);
	}
	
	
	public String lookupQuery(String query){
		
			HashMap<String,String> constants = new HashMap<String,String>();
		
		    Pattern pattern = Pattern.compile("\"[a-zA-z0-9]*\"");
		    Matcher matcher = pattern.matcher(query);
		    StringBuffer b = new StringBuffer();
		    int i = 0;
		    while (matcher.find()) {
		      String match = matcher.group();
		      matcher.appendReplacement(b, "\"" + "y" + i + "\"");
		      constants.put("\"" + "y" + i +"\"", match);
		      i++;
		    }
		    
		    matcher.appendTail(b);
		    
		   // System.out.println("LOOKING UP: " + b);
		    String s = lookupQueryTemplate(b.toString());
		    if(s==null)
		    	return null;
		    //System.out.println("FOUND IN CACHE:" + s);
		    
		    Pattern pattern2 = Pattern.compile("\"y[0-9]+\"");
		    Matcher matcher2 = pattern2.matcher(s);
		    StringBuffer output = new StringBuffer();
		   
		    while (matcher2.find()) {
		      String match = matcher2.group();
		      matcher2.appendReplacement(output,constants.get(match));
		    }
		    matcher2.appendTail(output);
	//	    System.out.println("MATCH REWRITING :" + output.toString());
		    
		    return output.toString();
			
	}
	
	
	public String lookupQueryTemplate(String template){
	
		return (String) cache.getObject(template);
		
	}

	public void addRewritingByQuery(String query, String rewriting){
		
		//System.out.println("ADDING: " + query +" -- " + rewriting);
		
	    Pattern pattern = Pattern.compile("\"[a-zA-z0-9]*\"");
	    Matcher matcher = pattern.matcher(query);
	    StringBuffer b = new StringBuffer();
	    int i = 0;
	    while (matcher.find()) {
	      String match = matcher.group();
	      matcher.appendReplacement(b, "\"" + "y" + i + "\"");
	      i++;
	    }
	    
	    matcher.appendTail(b);
	    
	    pattern = Pattern.compile("\"[a-zA-z0-9]*\"");
	    matcher = pattern.matcher(rewriting);
	    StringBuffer c = new StringBuffer();
	    i = 0;
	    while (matcher.find()) {
	      String match = matcher.group();
	      matcher.appendReplacement(c, "\"" + "y" + i + "\"");
	      i++;
	    }
	    
	    matcher.appendTail(c);
	    addRewritingByTemplate(b.toString(),c.toString());

		//System.out.println("ADDED: " + b.toString() +" -- " + c.toString());
		
	}
	
	public void addRewritingByTemplate(String template, String rewriting){
		cache.addObject(template, rewriting);
	}
	
}
