package edu.ucla.cs.db.prism.backend.rewrite.update;

import java.util.List;

import net.sf.jsqlparser.expression.AllComparisonExpression;
import net.sf.jsqlparser.expression.AnyComparisonExpression;
import net.sf.jsqlparser.expression.CaseExpression;
import net.sf.jsqlparser.expression.DateValue;
import net.sf.jsqlparser.expression.DoubleValue;
import net.sf.jsqlparser.expression.Expression;
import net.sf.jsqlparser.expression.ExpressionVisitor;
import net.sf.jsqlparser.expression.Function;
import net.sf.jsqlparser.expression.InverseExpression;
import net.sf.jsqlparser.expression.JdbcParameter;
import net.sf.jsqlparser.expression.LongValue;
import net.sf.jsqlparser.expression.NullValue;
import net.sf.jsqlparser.expression.Parenthesis;
import net.sf.jsqlparser.expression.StringValue;
import net.sf.jsqlparser.expression.TimeValue;
import net.sf.jsqlparser.expression.TimestampValue;
import net.sf.jsqlparser.expression.WhenClause;
import net.sf.jsqlparser.expression.operators.arithmetic.Addition;
import net.sf.jsqlparser.expression.operators.arithmetic.Division;
import net.sf.jsqlparser.expression.operators.arithmetic.Multiplication;
import net.sf.jsqlparser.expression.operators.arithmetic.Subtraction;
import net.sf.jsqlparser.expression.operators.conditional.AndExpression;
import net.sf.jsqlparser.expression.operators.conditional.OrExpression;
import net.sf.jsqlparser.expression.operators.relational.Between;
import net.sf.jsqlparser.expression.operators.relational.EqualsTo;
import net.sf.jsqlparser.expression.operators.relational.ExistsExpression;
import net.sf.jsqlparser.expression.operators.relational.ExpressionList;
import net.sf.jsqlparser.expression.operators.relational.GreaterThan;
import net.sf.jsqlparser.expression.operators.relational.GreaterThanEquals;
import net.sf.jsqlparser.expression.operators.relational.InExpression;
import net.sf.jsqlparser.expression.operators.relational.IsNullExpression;
import net.sf.jsqlparser.expression.operators.relational.ItemsListVisitor;
import net.sf.jsqlparser.expression.operators.relational.LikeExpression;
import net.sf.jsqlparser.expression.operators.relational.MinorThan;
import net.sf.jsqlparser.expression.operators.relational.MinorThanEquals;
import net.sf.jsqlparser.expression.operators.relational.NotEqualsTo;
import net.sf.jsqlparser.schema.Column;
import net.sf.jsqlparser.schema.Table;
import net.sf.jsqlparser.statement.select.SubSelect;

public class ExpressionAliasInjectorVisitor implements ExpressionVisitor, ItemsListVisitor {

	Table t = null;
	edu.ucla.cs.db.prism.backend.schema.Table prismTable;
	public ExpressionAliasInjectorVisitor(Table t, edu.ucla.cs.db.prism.backend.schema.Table prismTable){
	
		this.prismTable = prismTable;
		this.t=t;
	}
	
	public static Expression aliasExpression(Expression where, Table t, edu.ucla.cs.db.prism.backend.schema.Table prismTable) {
	
		// negate the expression with ExpressionNegateVisitor and return a negated expression
		ExpressionAliasInjectorVisitor nv = new ExpressionAliasInjectorVisitor(t, prismTable);		
		
		where.accept(nv);
		
		return where;
	}


	public void visit(NullValue nullValue) {
		
	}

	public void visit(Function function) {
		function.getParameters().accept(this);
	}

	public void visit(InverseExpression inverseExpression) {
		// TODO Auto-generated method stub
		
	}

	public void visit(JdbcParameter jdbcParameter) {
		// TODO Auto-generated method stub
		
	}

	public void visit(DoubleValue doubleValue) {
		// TODO Auto-generated method stub
		
	}

	public void visit(LongValue longValue) {
		// TODO Auto-generated method stub
		
	}

	public void visit(DateValue dateValue) {
		// TODO Auto-generated method stub
		
	}

	public void visit(TimeValue timeValue) {
		// TODO Auto-generated method stub
		
	}

	public void visit(TimestampValue timestampValue) {
		// TODO Auto-generated method stub
		
	}

	public void visit(Parenthesis parenthesis) {
		parenthesis.getExpression().accept(this);		
	}

	public void visit(StringValue stringValue) {

		
	}

	public void visit(Addition addition) {
		// TODO Auto-generated method stub
		
	}

	public void visit(Division division) {
		// TODO Auto-generated method stub
		
	}

	public void visit(Multiplication multiplication) {
		// TODO Auto-generated method stub
		
	}

	public void visit(Subtraction subtraction) {
		// TODO Auto-generated method stub
		
	}

	public void visit(AndExpression andExpression) {
		andExpression.getLeftExpression().accept(this);
		andExpression.getRightExpression().accept(this);
		
	}

	public void visit(OrExpression orExpression) {
		orExpression.getLeftExpression().accept(this);
		orExpression.getRightExpression().accept(this);
	}

	public void visit(Between between) {
	}

	public void visit(EqualsTo equalsTo) {
		
		equalsTo.getLeftExpression().accept(this);
		equalsTo.getRightExpression().accept(this);

		
	}

	public void visit(GreaterThan greaterThan) {
		
		greaterThan.getLeftExpression().accept(this);
		greaterThan.getRightExpression().accept(this);
		
	}

	public void visit(GreaterThanEquals greaterThanEquals) {
		greaterThanEquals.getLeftExpression().accept(this);
		greaterThanEquals.getRightExpression().accept(this);
		
	}

	public void visit(InExpression inExpression) {
		inExpression.getLeftExpression().accept(this);
		//FIXME something missing here
		
	}

	public void visit(IsNullExpression isNullExpression) {
		isNullExpression.getLeftExpression().accept(this);
		
	}

	public void visit(LikeExpression likeExpression) {
		likeExpression.getLeftExpression().accept(this);
		likeExpression.getRightExpression().accept(this);
		
	}

	public void visit(MinorThan minorThan) {
		minorThan.getLeftExpression().accept(this);
		minorThan.getRightExpression().accept(this);
		
		
	}

	public void visit(MinorThanEquals minorThanEquals) {
		minorThanEquals.getLeftExpression().accept(this);
		minorThanEquals.getRightExpression().accept(this);
		
	}

	public void visit(NotEqualsTo notEqualsTo) {
		notEqualsTo.getLeftExpression().accept(this);
		notEqualsTo.getRightExpression().accept(this);
		
	}

	public void visit(Column tableColumn) {
		
		if(prismTable.getColumnByName(tableColumn.getColumnName())!=null)
			tableColumn.setTable(t);
		
	}

	public void visit(SubSelect subSelect) {
		
	}

	public void visit(CaseExpression caseExpression) {
		// TODO Auto-generated method stub
		
	}

	public void visit(WhenClause whenClause) {
		// TODO Auto-generated method stub
		
	}

	public void visit(ExistsExpression existsExpression) {
		// TODO Auto-generated method stub
		
	}

	public void visit(AllComparisonExpression allComparisonExpression) {
		// TODO Auto-generated method stub
		
	}

	public void visit(AnyComparisonExpression anyComparisonExpression) {
		//TODO
	}

	public void visit(ExpressionList expressionList) {
		for(Object e:expressionList.getExpressions()){			
			((Expression)e).accept(this);
		}
	}

}
