package edu.ucla.cs.db.prism.backend.rewrite.update;

import java.util.Iterator;

import net.sf.jsqlparser.schema.Table;
import net.sf.jsqlparser.statement.select.AllColumns;
import net.sf.jsqlparser.statement.select.AllTableColumns;
import net.sf.jsqlparser.statement.select.ColumnReference;
import net.sf.jsqlparser.statement.select.FromItemVisitor;
import net.sf.jsqlparser.statement.select.Join;
import net.sf.jsqlparser.statement.select.PlainSelect;
import net.sf.jsqlparser.statement.select.SelectExpressionItem;
import net.sf.jsqlparser.statement.select.SelectItem;
import net.sf.jsqlparser.statement.select.SelectItemVisitor;
import net.sf.jsqlparser.statement.select.SelectVisitor;
import net.sf.jsqlparser.statement.select.SubJoin;
import net.sf.jsqlparser.statement.select.SubSelect;
import net.sf.jsqlparser.statement.select.Top;
import net.sf.jsqlparser.statement.select.Union;

public class SelectAliasInjectorVisitor implements SelectVisitor, SelectItemVisitor, FromItemVisitor{

	Table t = null;
	edu.ucla.cs.db.prism.backend.schema.Table prismTable;
	public SelectAliasInjectorVisitor(Table t, edu.ucla.cs.db.prism.backend.schema.Table prismTable){
	
		this.prismTable = prismTable;
		this.t=t;
	}
	
	
	public void visit(PlainSelect plainSelect) {

		for (Iterator iter = plainSelect.getSelectItems().iterator(); iter.hasNext();) {
			SelectItem selectItem = (SelectItem) iter.next();
			selectItem.accept(this);
		}
		
		if (plainSelect.getFromItem() != null) {
			plainSelect.getFromItem().accept(this);
		}


		if (plainSelect.getWhere() != null) {
			ExpressionAliasInjectorVisitor v = new ExpressionAliasInjectorVisitor(t,prismTable);
			plainSelect.getWhere().accept(v);
		}

		
	}

	public void visit(Union union) {
		// TODO Auto-generated method stub

	}

	public void visit(AllColumns allColumns) {
		// TODO Auto-generated method stub
		
	}

	public void visit(AllTableColumns allTableColumns) {
		
	}

	public void visit(SelectExpressionItem selectExpressionItem) {
		ExpressionAliasInjectorVisitor v = new ExpressionAliasInjectorVisitor(t,prismTable);
		selectExpressionItem.getExpression().accept(v);
		
	}

	public void visit(Table tableName) {
		
		tableName.setAlias(t.getName());
		
	}

	public void visit(SubSelect subSelect) {
		subSelect.accept(this);
	}

	public void visit(SubJoin subjoin) {
		// TODO Auto-generated method stub
		
	}

}
