package edu.ucla.cs.db.prism.backend.schema;

import java.io.Serializable;
import java.util.Vector;

public class TableModifiedInfo extends Table implements Serializable {
	static final long serialVersionUID = 0;
	public boolean tableModifiedFlag;
	public Vector<Boolean> columnsModifiedFlag;
	
	public TableModifiedInfo(String tableName, boolean tableModifiedFlag) {
		super(tableName);
		this.tableModifiedFlag = tableModifiedFlag;
		this.columnsModifiedFlag = new Vector<Boolean>();
	}
	
	public TableModifiedInfo(TableModifiedInfo srcTable) {
		super(new String(srcTable.getTableName()));
		this.tableModifiedFlag = srcTable.tableModifiedFlag;
		this.columnsModifiedFlag = new Vector<Boolean>();
		for(int i=0; i<srcTable.getColumns().size(); i++) 
			this.getColumns().add(new String(srcTable.getColumns().get(i)));
		for(int i=0; i<srcTable.columnsModifiedFlag.size(); i++) 
			this.columnsModifiedFlag.add(new Boolean(srcTable.columnsModifiedFlag.get(i)));
	}
	
	public void addColumn(String columnName, boolean columnModifiedFlag) {
		super.addColumn(columnName);
		columnsModifiedFlag.add(new Boolean(columnModifiedFlag));
	}
	
	@Override
	public void addColumn(String columnName) {
		return; // disallow columnname only insertion - modifiedflag should accompany
	}
	
	public boolean getColumnModifiedFlag(int index) {
		return columnsModifiedFlag.get(index).booleanValue();
	}

	public boolean getColumnModifiedFlag(String columnName) {
		int index;
		for(index=0; index<super.getNumColumns(); index++)
			if(getColumns().get(index).contentEquals(columnName))
				break; // found
		
		return columnsModifiedFlag.get(index).booleanValue();
	}
	
	public void removeColumn(int index) {
		this.getColumns().remove(index);
		this.columnsModifiedFlag.remove(index);
	}

}
