package edu.ucla.cs.db.prism.backend.smo;

import java.util.Vector;

import edu.ucla.cs.db.prism.backend.ded.DEDSet;
import edu.ucla.cs.db.prism.backend.schema.Schema;
import edu.ucla.cs.db.prism.backend.smo.util.SMOSequenceInterface;
import edu.ucla.cs.db.prism.backend.smo.util.SMOSequence;

public interface SMOInterface {

	public static final String DROP_TAB ="DROP TABLE";
	public static final String CREATE_TAB ="CREATE TABLE";
	public static final String COPY_TAB ="COPY TABLE";
	public static final String REN_TAB ="RENAME TABLE";
	public static final String REN_COL ="RENAME COLUMN";
	public static final String DROP_COL ="DROP COLUMN";
	public static final String ADD_COL ="ADD COLUMN";
	public static final String PARTITION ="PARTITION TABLE";
	public static final String MERGE ="MERGE TABLE";
	public static final String JOIN ="JOIN TABLE";
	public static final String DECOMPOSE ="DECOMPOSE TABLE";
	public static final String NOP ="NOP";
	
	public abstract DEDSet getDEDs(Schema inputSchema);
	
	public abstract String toString();

	public abstract Vector<String> getModifiedInputSchemaParts();

	public abstract Vector<String> getModifiedExistingTables(
			Schema queryFootprintTargetSchema);

	public abstract SMOSequenceInterface getInverse();

	public abstract Vector<SMOSequence> getCandidateInverses(Schema inputSchema);
	
	public abstract int getSmo_id();

	public abstract void setId(int smo_id);

	public abstract int getSourceMajor();

	public abstract void setSourceMajor(int source_Major);

	public abstract int getSourceMinor();

	public abstract void setSourceMinor(int source_Minor);

	public abstract int getTargetMajor();

	public abstract void setTargetMajor(int target_Major);

	public abstract int getTargetMinor();

	public abstract void setTargetMinor(int target_Minor);

	public abstract String getComment();

	public abstract void setComment(String comment);

	public abstract void setOperatorType(String operatorType);

	public abstract String getOperatorType();

	public abstract void setTableName(String tableName);

	public abstract String getTableName();

	public abstract void setTableName2(String tableName2);

	public abstract String getTableName2();

	public abstract void setTableName3(String tableName3);

	public abstract String getTableName3();

	public abstract void setColumnName(String columnName);

	public abstract String getColumnName();

}