package edu.ucla.cs.db.prism.backend.temporalOptimize;

public class VersionInterval {
	public int version;
	public String startTime; // inclusive
	public String endTime; // exclusive
	public static final String maximumTimeInstance = "\"9999-12-31\"";
	
	public VersionInterval() {
		version = -1;
		startTime = null;
		endTime = null;
	}
	
	public VersionInterval(int version, String startTime) {
		this.version = version;
		this.startTime = startTime;
		endTime = null;
	}
	
	public boolean contains(String timeInstance) {
		return startTime.compareTo(timeInstance) <= 0 &&
				timeInstance.compareTo(endTime) < 0;
	}
	
	@Override
	public String toString() {
		return "V(" + version + "): [" + startTime + "," + endTime + ")"; 
	}
	
}
