package edu.ucla.cs.db.prism.backend.util;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;

public class ProcessExec {

	static public void execUtil(String command, String stdinFile, String timerMsg) {
		Runtime runtime = Runtime.getRuntime();
		Stopwatch timer = new Stopwatch();
		
		//command = "dir > out.txt";
		//System.out.println(command);
		
		String outFileName = "execUtilOut.txt";
		String errFileName = "execUtilError.txt";
		try {
			// output, error msg
        	BufferedWriter outBW = new BufferedWriter(new FileWriter(outFileName));
        	BufferedWriter errBW = new BufferedWriter(new FileWriter(errFileName));

        	// input
        	BufferedReader inBR = null;
        	if(stdinFile != null)
        		inBR = new BufferedReader(new FileReader(stdinFile));

        	timer.start();
        	Process p = runtime.exec(command);

			
            // any output?
			StreamHandler outputHandler = new 
				StreamHandler(p.getInputStream(), outBW, "OUTPUT");

            // any error message?
			StreamHandler errorHandler = new 
				StreamHandler(p.getErrorStream(), errBW, "ERROR");            
            
			// any input?
			StreamHandlerStdin stdinHandler = null;
			if(inBR != null)
				stdinHandler = new StreamHandlerStdin(p.getOutputStream(), inBR);
			
            // kick them off
			outputHandler.start();
			errorHandler.start();
			if(stdinHandler != null) {
				stdinHandler.start();
			}
			
			try {
				p.waitFor();
			} catch(InterruptedException ex) {}
			timer.stop();
			
			if(timerMsg != null)
				System.out.println(timerMsg + timer.getElapsedTime() + " ms");
			//System.out.println("process terminated with code = "+p.exitValue());
			
			//inBrStdout.close();
			outBW.close();
			errBW.close();
			inBR.close();
			
			// echo the contents of outFileName ot stdout
			System.out.print(ReadWriteTextFile.getContents(new File(outFileName)));
			
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
}
