package edu.ucla.cs.db.prism.backend.util;

/**
 * A class to help benchmark code
 * It simulates a real stop watch
 * Copied from 
 * http://java.sun.com/docs/books/performance/1st_edition/html/JPMeasurement.fm.html
 */
public class Stopwatch {

  private long startTime = -1;
  private long stopTime = -1;
  private boolean running = false;

  public void start() {
     startTime = System.currentTimeMillis();
     running = true;
  }
  public long stop() {
	 if(running) {
		 stopTime = System.currentTimeMillis();
		 running = false;
	     return stopTime - startTime;
	 }
	 else { // error - stopping non-running stopwatch
		 reset();
		 return -1;
	 }
  }
  /** returns elapsed time in milliseconds
    * if the watch has never been started then
    * return -1
    */
  public long getElapsedTime() {
     if (startTime == -1) {
        return -1;
     }
     if (running){
     return System.currentTimeMillis() - startTime;
     } else {
     return stopTime-startTime;
     } 
  }

  public Stopwatch reset() {
     startTime = -1;
     stopTime = -1;
     running = false;
     return this;
  }
}
