package edu.ucla.cs.db.prism.backend.xquery;

public class ForClause {
	public String var;
	public XQuery valueSeq;

	// 9-13-2007 by Hyun
	public String relationAttribute; // var = r1.a2 - used for ChasePostProcessing
	
	// simple for clause constructor
	// "for var in path"
	public ForClause() {
	}

	public ForClause(String var, String path) {
		this.var = var;
		valueSeq = new XQuery();
		valueSeq.type = 0;
		valueSeq.path = path;
	}

	
	@Override
	public boolean equals(Object o) {
		ForClause fc2 = (ForClause)o;
		return this.var.equals(fc2.var) && this.valueSeq.equals(fc2.valueSeq);
	}
	
	@Override
	public ForClause clone() {
		ForClause newForClause = new ForClause();
		newForClause.var = this.var;
		newForClause.valueSeq = this.valueSeq.clone();
		return newForClause;
	}
	
	public String getVarWithoutPrefix() {
		return var.substring(1); // return without '$'
	}

	public void setVarWithPrefix(String newVar) {
		var = "$" + newVar; // set with '$'
	}
	
	private String stripBraces(String str) {
		// input: { path }
		// output: path
		if(str.charAt(0) == '{')
			str = str.substring(1);
		if(str.charAt(str.length()-1) == '}')
			str = str.substring(0, str.length()-1);
		return str;
	}
	
	private String documentAccessAppend(String path) {
		if(path.startsWith("document(\"")) // e.g. document("doc.xml")/db
			return "$doc" + path.substring(path.lastIndexOf("/"));
		else if(path.startsWith("/")) // e.g. /db
			return "$doc" + path;
		else
			return path;
	}

	@Override
	public String toString() {
		return toString(0);
	}
	
	public String toString(int indentLevel) {
		String str = "";
		
		String stringForValueSeq = null;
		if(valueSeq.type == 0)
			stringForValueSeq = valueSeq.toString();
		else
			stringForValueSeq = valueSeq.toString(indentLevel);
		
		//str += var + " in " + documentAccessAppend(stripBraces(stringForValueSeq));
		str += var + " in " + documentAccessAppend(stringForValueSeq);
		return str;
	}
}
