package edu.ucla.cs.db.prism.backend.xquery;

public class XPath {

	static public boolean isAboslutePath(String path) {
		if(path == null || path.length() == 0)
			return false;
		else if(path.startsWith("/"))
			return true;
		else
			return false;
	}

	static public boolean isRelativePath(String path) {
		return startsAtVariable(path);
	}
	
	static public boolean startsAtVariable(String path) {
		if(path == null || path.length() == 0)
			return false;
		else if(path.startsWith("$"))
			return true;
		else
			return false;
	}

	// return {firstSimplePath, rest} where firstSimplePath is a variable or an element
	//  such as $a, db, row.
	static public String[] extractFirstSimplePath(String path) {
		if(path == null || path.length() == 0)
			return null;
		
		while(path.charAt(0) == '/')
			path = path.substring(1);

		String firstSimplePath=null, rest=null;
		int nextSlashIndex = path.indexOf('/');
		if(nextSlashIndex >= 0) {
			firstSimplePath = path.substring(0, nextSlashIndex);
			rest = path.substring(nextSlashIndex+1);
		}
		else {// nextSlashIndex == -1, not found
			firstSimplePath = path;
			rest = null;
		}
		
		String[] returnValue = {firstSimplePath, rest};
		return returnValue;
	}
	
	static public boolean isAttributeNode(String path) {
		return path.startsWith("@");
	}

	static public boolean isTextNode(String path) {
		return path.equals("text()");
	}
	
	static public String stripDocument(String path) {
		// input: document("doc.xml")/element
		// output: /element
		if(!path.startsWith("document(\""))
			return path;
		
		int index = path.lastIndexOf("/");
		if(index<0)
			return null; // error
		else
			return path.substring(index);
			
		
	}
	
}
