package edu.ucla.cs.db.prism.gui.client;

import java.io.Serializable;


public class ClientQueryRewriteResult implements Serializable {
	
		
		/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
		public String[] inputqueries;
		public String[] rewrittenqueries;
		public int[] results;

		public ClientQueryRewriteResult(){
			
		}
		
		public ClientQueryRewriteResult(String[] inputqueries){
			
			this.inputqueries = inputqueries; 
			this.rewrittenqueries = new String[this.inputqueries.length];
			this.results = new int[this.inputqueries.length];
			
		}
		
		public ClientQueryRewriteResult(String[] inputqueries, String[] rewrittenqueries, int[] results) {
			this.inputqueries = inputqueries;
			this.rewrittenqueries = rewrittenqueries;
			this.results = results;
		}

		/**
		 * Compute and return percentage of success rate
		 * @return
		 */
		public float percentageSuccessRate(){
				int success = 0;
				for(int i = 0; i< results.length; i++){
					success += results[i]; 
				}
				return (float)success / (float)results.length * 100;
		}

		/**
		 * return the number of queries in the query rewrite result
		 * @return
		 */
		public int size() {
			return inputqueries.length;
		} 
		
	
}
