package edu.ucla.cs.db.prism.gui.client;

import java.io.Serializable;
import java.util.Iterator;
import java.util.Vector;

public class ClientSchema implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	String schemaName = null;
	int majorVersion = -1;
	int minorVersion = -1;
	String tstart = "";
	String tend = "";
	

	Vector<ClientTable> tables = null;
	
	Vector<String> modifiedVector = null;
	public String error = null;
	
	public ClientSchema(){

	}
	public ClientSchema(String schemaName, int major, int minor, String tstart, String tend){
		this.schemaName = schemaName;
		majorVersion = major;
		minorVersion = minor;
		this.tstart = tstart;
		this.tend = tend;
		tables = new Vector<ClientTable>();
		modifiedVector = new Vector<String>();
		
	}
	
	public void addTable(ClientTable t, String modified){
		
		if(!modified.equals("u")){
			tables.add(0,t);
			modifiedVector.add(0,modified);
		}else{
			tables.add(t);
			modifiedVector.add(modified);		
		}
			
	}
	
	public void reorder(){
		
		
		
	} 
	
	@Override
	public String toString(){
		
		if(this.error!= null)
			return error;
		
		if(schemaName == null)
			return "_ empty schema _";
		String out = "<h3>" + schemaName + "</h3> Validity from: " + tstart + " to: " +tend +"<br><br><schema> ";
		Iterator<ClientTable> it = tables.iterator();
		
		while(it.hasNext()){
			Object o = it.next();
			out +="<table>" + o.toString() + "</table><br>";			
		}
		return out + "</schema>";
	}
	
	public String toPopupString(){
		if(schemaName == null)
			return "_ empty schema _";
		String out = "<pschema>";
		// list reverse to show modified elements first!
		for(int i = 0; i<tables.size(); i++){
			Object o = tables.elementAt(i);
			Object mod = modifiedVector.elementAt(i);
			out +="<ptable_" + mod.toString() + ">" + o.toString() + "</ptable_"+mod.toString()+"><br>";			
		}
		//System.out.println(out);
		return out + "</pschema>";
	}
	
	public String toPopupStringNoTypes(){
		if(schemaName == null)
			return "_ empty schema _";
		String out = "<pschema>";
		// list reverse to show modified elements first!
		for(int i = 0; i<tables.size(); i++){
			Object o = tables.elementAt(i);
			Object mod = modifiedVector.elementAt(i);

			//if we want to not show the violation tables it is enough to uncomment the next line
			//if(!((ClientTable) o).tableName.contains("__viol"))
			
			out +="<ptable_" + mod.toString() + ">" + ((ClientTable) o).toStringNoTypes() + "</ptable_"+mod.toString()+"><br>";			
		}
		//System.out.println(out);
		return out + "</pschema>";
	}
		
}
