package edu.ucla.cs.db.prism.gui.client;

import java.io.Serializable;
import java.util.Iterator;
import java.util.Vector;


public class ClientTable implements Serializable{

	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	Vector<ClientColumn> columns = null;
	Vector<String> colModified = null;
	String tableName = null;
	Vector<String> constraints = null;

	public ClientTable(){
		
	}
	public ClientTable(String tableName){
		columns = new Vector<ClientColumn>();
		colModified = new Vector<String>();
		constraints = new Vector<String>();
		this.tableName = tableName;
	}
	
	public void addConstraints(Vector<String> constr){
		constraints.addAll(constr);
	}
	
	
	public void addColumn(ClientColumn col, String mod){
		columns.add(col);
		colModified.add(mod);
	}
	
	public ClientColumn getColumn(String colName){
		Iterator<ClientColumn> it = columns.iterator();	
		while(it.hasNext()){
			ClientColumn cc = it.next();
			if(cc.columnName.equalsIgnoreCase(colName))
				return cc;
		}
		return null;
	}
	
	@Override
	public String toString(){
		String out = "<b>" + tableName + "</b>(";
		Iterator<ClientColumn> it = columns.iterator();
		Iterator<String> mit = colModified.iterator();

		while(it.hasNext()){
			String mod = mit.next().toString();
			out +="<col_"+mod+">" + (it.next()).toString() + "</col_" + mod + ">";
			if(it.hasNext())
				out+=", ";
		}
		out+=") ";
		if(constraints.size()>0)
			out += constraints.toString();
		
		return out + "; ";
	}
	
	public String toStringNoTypes() {
		String out = "<b>" + tableName + "</b>(";
		Iterator<ClientColumn> it = columns.iterator();
		Iterator<String> mit = colModified.iterator();

		while(it.hasNext()){
			String mod = mit.next().toString();
			out +="<col_"+mod+">" + (it.next()).toStringNoTypes() + "</col_" + mod + ">";
			if(it.hasNext())
				out+=", ";
		}
		
		out+=") ";
		if(constraints.size()>0)
			out += constraints.toString();
		return out + "; ";
	}

}
