package edu.ucla.cs.db.prism.gui.server;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Random;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;

import edu.ucla.cs.db.prism.backend.BackendUtil;
import edu.ucla.cs.db.prism.backend.ICBackendUtil;
import edu.ucla.cs.db.prism.backend.exception.SchemaErrorException;
import edu.ucla.cs.db.prism.backend.icmo.MOImpl;
import edu.ucla.cs.db.prism.backend.rewrite.QueryRewriteResult;
import edu.ucla.cs.db.prism.backend.rewrite.QueryRewriteResultSet;
import edu.ucla.cs.db.prism.backend.schema.Schema;
import edu.ucla.cs.db.prism.backend.schema.Table;
import edu.ucla.cs.db.prism.backend.schema.integrityconstraints.ICSchema;
import edu.ucla.cs.db.prism.backend.schema.integrityconstraints.ICSchemaHistory;
import edu.ucla.cs.db.prism.backend.schema.integrityconstraints.ICTable;
import edu.ucla.cs.db.prism.backend.schema.integrityconstraints.exceptions.SchemaMismatchException;
import edu.ucla.cs.db.prism.backend.smo.SMOImpl;
import edu.ucla.cs.db.prism.backend.icmo.ICMOSMOSequence;
import edu.ucla.cs.db.prism.backend.smo.util.SMOSequence;
import edu.ucla.cs.db.prism.backend.util.Log4JHelper;
import edu.ucla.cs.db.prism.gui.client.ClientColumn;
import edu.ucla.cs.db.prism.gui.client.ClientQueryRewriteResult;
import edu.ucla.cs.db.prism.gui.client.ClientOperator;
import edu.ucla.cs.db.prism.gui.client.ClientOperatorSequence;
import edu.ucla.cs.db.prism.gui.client.ClientSchema;
import edu.ucla.cs.db.prism.gui.client.ClientState;
import edu.ucla.cs.db.prism.gui.client.ClientTable;
import edu.ucla.cs.db.prism.gui.client.PrimBackendService;
import edu.ucla.cs.db.prism.gui.client.SingleQueryRewriteResult;

public class PrimBackendServiceImpl extends RemoteServiceServlet implements PrimBackendService {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public HashMap<String, ServerSideClientState> clientstates = new HashMap<String, ServerSideClientState>();
	//STATIC LOGGER
	static Logger logger = Logger.getLogger(PrimBackendServiceImpl.class);

	public PrimBackendServiceImpl(){
		super();
	    Log4JHelper.log4JSetup(logger,Level.DEBUG);	
	}
	
	public String myMethod(String s) {
		return DBLoader.getFirstSchemaString();
	}
	
	/**
	 * This method interrogate the backend asking to retrieve the representation of a given Schema
	 * and convert it into a ClientSchema representation to be managed on the AJAX client.
	 */
	/*public ClientSchema getSchemaByVersion(int majorVersion, int minorVersion){
		Schema backSchema = DBLoader.getSchemaByVersion(majorVersion, minorVersion);
		if(backSchema == null)
			logger.error("getSchemaByVersion() NO SCHEMA FOR VERSION " + majorVersion + "."+ minorVersion);  
		return schemaConversion(backSchema,backSchema);
	}

	public ClientSchema getSchemaByName(String dburl, String user, String password, String schemaName) {
		Schema backSchema = DBLoader.getSchemaByName(dburl, user, password,  schemaName);
		if(backSchema == null)
			logger.error("getSchemaByVersion() NO SCHEMA FOR  " + dburl + ", "+ user + ", " +schemaName);  
		return schemaConversion(backSchema,backSchema);
	}

	public ClientOperatorSequence getHistoricalSMO(String cookiekey){
		
		ClientState cs = clientstates.get(cookiekey).cs;
		SMOSequenceHistory ssh = DBLoader.getSMO(cs.dburltb, cs.usertb, cs.passwordtb, cs.metaSchemaName, cs.schemaName);
		
		return SMOSequenceHistoryConversion(ssh);
	}*/
	
	public ClientOperatorSequence getCurrentSMOs(String cookiekey){
		BackendUtil b = clientstates.get(cookiekey).be;
		
		if(b == null)
			return null;
		
		SMOSequence ssh = b.getCurrentSMOs();
			
		if(b instanceof ICBackendUtil)	
			return SMOSequenceConversion(ssh);
		else
			return SMOSequenceConversion(ssh);
		
	}
	
	/*private ClientOperatorSequence SMOSequenceHistoryConversion(SMOSequenceHistory ssh) {
		Vector<ClientOperator> smos = new Vector<ClientOperator>();
		for(int i = 0 ; i<ssh.smoSequences.size(); i++){
			Vector<MOImpl> tmp = ((ICMOSMOSequence) ssh.smoSequences.get(i)).getMos();
			for(int j = 0 ; j< tmp.size(); j++){
				MOImpl impl = tmp.get(j);
				smos.add( new ClientOperator(impl.getSourceMajor(), 
									   impl.getSourceMinor(),
									   impl.getTargetMajor(),
									   impl.getTargetMinor(),
									   impl.toString(),
									   impl.isComplete()));
			}	
		}
		ClientOperatorSequence clss = new ClientOperatorSequence(smos.firstElement().getMajorSourceVersion(),
													   smos.firstElement().getMinorSourceVersion(),
													   smos.lastElement().getMajorTargetVersion(),
													   smos.lastElement().getMinorTargetVersion());
		clss.smos = smos;
		
		return clss;
	}*/
	
	
	private ClientOperatorSequence SMOSequenceConversion(SMOSequence ssh) {
		Vector<ClientOperator> smos = new Vector<ClientOperator>();
		
		if(ssh instanceof ICMOSMOSequence){
			Vector<MOImpl> tmp = ((ICMOSMOSequence) ssh).getMos();
			if(!tmp.isEmpty()){
				for(int j = 0 ; j< tmp.size(); j++){
					smos.add(new ClientOperator(tmp.get(j).getSourceMajor(), 
										   tmp.get(j).getSourceMinor(),
										   tmp.get(j).getTargetMajor(),
										   tmp.get(j).getTargetMinor(),
										   tmp.get(j).toString(),tmp.get(j).isComplete()));
				}	
				
				ClientOperatorSequence clss = new ClientOperatorSequence((smos.firstElement()).getMajorSourceVersion(),
															   (smos.firstElement()).getMinorSourceVersion(),
															   (smos.lastElement()).getMajorTargetVersion(),
															   (smos.lastElement()).getMinorTargetVersion());
				clss.smos = smos;
				
				return clss;
			}
			
		}else{
				Vector<SMOImpl> tmp = ssh.smos;
				
				if(!tmp.isEmpty()){
					for(int j = 0 ; j< tmp.size(); j++){
						smos.add(new ClientOperator(tmp.get(j).getSourceMajor(), 
											   tmp.get(j).getSourceMinor(),
											   tmp.get(j).getTargetMajor(),
											   tmp.get(j).getTargetMinor(),
											   tmp.get(j).toString(),tmp.get(j).isComplete()));
					}	
					
					ClientOperatorSequence clss = new ClientOperatorSequence((smos.firstElement()).getMajorSourceVersion(),
																   (smos.firstElement()).getMinorSourceVersion(),
																   (smos.lastElement()).getMajorTargetVersion(),
																   (smos.lastElement()).getMinorTargetVersion());
					clss.smos = smos;
					
					return clss;
				}
		}
		return null;
	}

	/**
	 * This method computes the conversion between Schema and ClientSchema. Using an old version of the schema also set deleted and added bits to improve rendering.
	 * @param backSchema
	 * @return ClientSchema
	 */
	private ClientSchema schemaConversion(Schema backSchema, Schema old){
	
		if(backSchema instanceof ICSchema && old instanceof ICSchema)
			return ICschemaConversion((ICSchema)backSchema,(ICSchema)old);
		
		if(old== null || backSchema == null)
			return null;
		
		Schema oldBackendSchema = old.clone();
		
		ClientSchema cs = null;
		if(backSchema.tstart==null ||backSchema.tend==null )
			cs = new ClientSchema(backSchema.getSchemaName(),backSchema.versionID, backSchema.minorVersionID,"1970-01-01 01:01:01","1970-01-01 01:01:01");
		else		
			cs = new ClientSchema(backSchema.getSchemaName(),backSchema.versionID, backSchema.minorVersionID,backSchema.tstart.toString(),backSchema.tend.toString());
		
		ClientTable ct = null;
		
	
		Iterator<Table> tit = backSchema.getTables().iterator();
		
		while(tit.hasNext()){
			Table curTab = tit.next();
			String mod = "u";
			Table oldTab = oldBackendSchema.getTable(curTab.getTableName());
			
			if(oldTab==null)
				mod = "a";
			else
				oldBackendSchema.getTables().remove(oldTab);
			
			ct = new ClientTable(curTab.getTableName());	
			Iterator<String> colit = curTab.getColumns().iterator();
			Iterator<String> typesit = curTab.getColTypes().iterator();
			while(colit.hasNext() && typesit.hasNext()){
				String colName = colit.next();
				String colType = typesit.next();
				String colMod = "a";
				if(oldTab!=null){
					String cc = oldTab.getColType(colName);
					oldTab.removeColumn(colName);
					if(cc!=null)
						if(cc.equals(colType))
							colMod = "u";
				}
				ct.addColumn(new ClientColumn(colName,colType),colMod);
			}
			
			if(oldTab!=null){
				// OLD COLUMNS REMOVED are added and overlined in the rendering!
				colit = oldTab.getColumns().iterator();
				typesit = oldTab.getColTypes().iterator();
				while(colit.hasNext() && typesit.hasNext()){
					String colName = colit.next();
					String colType = typesit.next();
					String colMod = "r"; // set the column as removed!
					ct.addColumn(new ClientColumn(colName,colType),colMod);
				}
			}
			
			cs.addTable(ct,mod);
		}
		
		// process all the tables removed but present in the old schema in the oldSchema
		if(!oldBackendSchema.getTables().isEmpty()){
			
			Iterator<Table> oldit = oldBackendSchema.getTables().iterator();
			while(oldit.hasNext()){
				Table t = oldit.next();
				ct = new ClientTable(t.getTableName());	
				Iterator<String> colit = t.getColumns().iterator();
				Iterator<String> typesit = t.getColTypes().iterator();
				while(colit.hasNext()){
					String colName = colit.next();
					String colType = typesit.next();
					String colMod = "u";
					colMod = "r";
					ct.addColumn(new ClientColumn(colName,colType),colMod);
				}
				cs.addTable(ct,"r");
			}
		}		
		return cs;
				
	}
	
	private ClientSchema ICschemaConversion(ICSchema backSchema, ICSchema old){
		

		ICSchema oldBackendSchema = old.clone();
		if(backSchema == null)
			return null;
		//System.out.println(backSchema.toStringWithMetadata());
		
		String tstart = backSchema.tstart.toString();
		String tend = backSchema.tend.toString();
		
		ClientSchema cs = new ClientSchema(backSchema.getSchemaName(),backSchema.versionID, backSchema.minorVersionID,tstart,tend);
		ClientTable ct = null;
		Iterator<ICTable> tit = backSchema.ictables.iterator();
		
		while(tit.hasNext()){
			ICTable curTab = tit.next();
			String mod = "u";
			ICTable oldTab = oldBackendSchema.getTable(curTab.getTableName());
			
			if(oldTab==null)
				mod = "a";
			else
				oldBackendSchema.ictables.remove(oldTab);
			
			ct = new ClientTable(curTab.getTableName());	
			Iterator<String> colit = curTab.getColumns().iterator();
			Iterator<String> typesit = curTab.getColTypes().iterator();
			while(colit.hasNext() && typesit.hasNext()){
				String colName = colit.next();
				String colType = typesit.next();
				String colMod = "a";
				if(oldTab!=null){
					String cc = oldTab.getColType(colName);
					oldTab.removeColumn(colName);
					if(cc!=null)
						if(cc.equals(colType))
							colMod = "u";
				}
				ct.addColumn(new ClientColumn(colName,colType),colMod);
			}
			
			if(oldTab!=null){
				// OLD COLUMNS REMOVED are added and overlined in the rendering!
				colit = oldTab.getColumns().iterator();
				typesit = oldTab.getColTypes().iterator();
				while(colit.hasNext() && typesit.hasNext()){
					String colName = colit.next();
					String colType = typesit.next();
					String colMod = "r"; // set the column as removed!
					ct.addColumn(new ClientColumn(colName,colType),colMod);
				}
			}
			
			
			ct.addConstraints(curTab.getConstraintsAsStringVector());
			
			cs.addTable(ct,mod);
		}
		
		// process all the tables removed but present in the old schema in the oldSchema
		if(!oldBackendSchema.getTables().isEmpty()){
			
			Iterator<Table> oldit = oldBackendSchema.getTables().iterator();
			while(oldit.hasNext()){
				Table t = oldit.next();
				ct = new ClientTable(t.getTableName());	
				Iterator<String> colit = t.getColumns().iterator();
				Iterator<String> typesit = t.getColTypes().iterator();
				while(colit.hasNext()){
					String colName = colit.next();
					String colType = typesit.next();
					String colMod = "u";
					colMod = "r";
					ct.addColumn(new ClientColumn(colName,colType),colMod);
				}
				cs.addTable(ct,"r");
			}
		}		
		return cs;
		
	}

	public ClientOperatorSequence addSMO(String tempc, String smotext){
		
		BackendUtil b = clientstates.get(tempc).be;
		
		logger.info(clientstates.get(tempc).ip +"SMO issued:" + smotext + "\n");
		
		if(b instanceof ICBackendUtil)
			return SMOSequenceConversion(((ICBackendUtil)b).addNewSMO(smotext));
		else
			return SMOSequenceConversion(b.addNewSMO(smotext));
	}
	
	
	public ClientOperatorSequence addMultipleSMO(String tempc, String[] smotext){
		
		logger.info(clientstates.get(tempc).ip +"SMO issued:" + smotext + "\n");
		
		BackendUtil b = clientstates.get(tempc).be;
		if(b instanceof ICBackendUtil)
			return SMOSequenceConversion(((ICBackendUtil)b).addMultipleNewSMO(smotext));
		else
			return SMOSequenceConversion(b.addMultipleNewSMO(smotext));
	}

   /**
    * @deprecated
    * @param dburltb
    * @param usertb
    * @param metaSchemaName
    * @param schemaName
    * @param major
    * @param minor
    * @return
    */
	@Deprecated
	public ClientSchema getSchemaByVersion(String dburltb, String usertb,
			String metaSchemaName, String schemaName, int major, int minor) {

		return null;
	}

	/**
	 * check SMO syntax and applicability to the current schema.
	 */
	public String smoSyntaxCheck(String key, String smotext,int schemaIndex, boolean isInverse) {
		
		BackendUtil b = clientstates.get(key).be;
	
		if(b instanceof ICBackendUtil)
			return ((ICBackendUtil)b).testSMOSyntax(smotext,schemaIndex,isInverse);
		else
			return b.testSMOSyntax(smotext,schemaIndex,isInverse);	
	}
	
	/**
	 * check SMO syntax and applicability to the current schema.
	 */
	public String smoSyntaxCheckByVersion(String key, String smotext,int major, int minor, boolean isInverse) {
		
		BackendUtil b = clientstates.get(key).be;
		try {
			return b.testSMOSyntax(smotext,major, minor,isInverse);
		} catch (SchemaErrorException e) {
			e.printStackTrace();
		}
		return "Schema Management exception, check server logs for details.";
	}

	/**
	 * Apply the input SMO to the schema version specified and return the resulting Schema if no error occurs.
	 */
	public ClientSchema applySMO(String cookiekey, String smotext) {
	
		ServerSideClientState temp = clientstates.get(cookiekey);
		
		if(temp.be instanceof ICBackendUtil)
			return schemaConversion(((ICBackendUtil)temp.be).applyMO(smotext),temp.be.startingSchema);
				
		return schemaConversion(temp.be.applyMO(smotext),temp.be.startingSchema);
	}

	/**
	 * Check whether an SMO is information preserving or not.
	 */
	public String informationPreservation(String cookiekey, String smotext,int schemaIndex) {
		BackendUtil b = clientstates.get(cookiekey).be;
		return b.informationPreservation(smotext);
	}
	
	/**
	 * Check whether an SMO is information preserving or not.
	 */
	public String checkRedundancy(String cookiekey, String smotext) {
		BackendUtil b = clientstates.get(cookiekey).be;
		return b.checkRedundancy(smotext);
	}
	

	
	/** 
	 * Generate on the server an object representing the client state, and return a cookie to later access it.
	 */
	public String startSession() {
		Random t = new Random();
		int cookiecode = t.nextInt();
		String key ="prism-state:"+cookiecode;
		
		HttpServletRequest t1 = getThreadLocalRequest(); 
		ServerSideClientState sscs = new ServerSideClientState(t1.getRemoteAddr());
		clientstates.put(key, sscs);
		logger.info("New Session with IP:" + t1.getRemoteAddr());

		return key;	
	}

	/**
	 * Set the client state, open up connection to the backend DB, as a side effect SMOs and schema history are prefetched.
	 */
	public String setState(String key, ClientState cs) {
		if(clientstates.containsKey(key)){
			clientstates.get(key).setClientState(cs,cs.getICSupport());
			return "ok";	
		}else{
			return "ERROR: cookie not known";
		}
	}
	
	
	public Vector<ClientSchema> getExistingSchemaHistory(String cookie){
		
		Vector<ClientSchema> output = new Vector<ClientSchema>();
		if(clientstates.get(cookie)!=null){
			Vector<ICSchema> vec = ((ICSchemaHistory)((ICBackendUtil)clientstates.get(cookie).be).sh).schemas;
			
			for(Schema v:vec){
				output.add(schemaConversion(v,v));
			}
			
			return output;
		}
		
		return null;
	}
	
	public String compareExistingSchema(String cookie, int maj1,boolean checktype){
		
		if(clientstates.get(cookie)!=null){
			ICBackendUtil b = ((ICBackendUtil)clientstates.get(cookie).be);
			try {
				if(b.compareSchemaInHistory(b.getCurrentSchema(), maj1, 0,checktype))
					return "schema match";
				else
					return "schema mismatch";
			} catch (SchemaMismatchException e) {
				//e.printStackTrace();
				return "schema mismatch: " +e.getMessage();
			}	
		}
		
		return null;
	}
	
	
	/**
	 * Return the current client state as seen by the server
	 * @param cookie
	 * @return
	 */
	public ClientState getState(String cookie){
		if(clientstates.get(cookie)!=null)
			return clientstates.get(cookie).cs;
		else
			return null;
	}	
		
	/**
	 * Drop a client state from the server.
	 */
	public String closeSession(String cookie) {
		try {
			clientstates.get(cookie).be.conn.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		clientstates.remove(cookie);
		HttpServletRequest t1 = getThreadLocalRequest(); 

		logger.info("session closed IP:" + t1.getRemoteAddr());
		return "session closed";	
	}



	public ClientOperatorSequence removeSMO(String cookiekey, int index) {
		BackendUtil b = clientstates.get(cookiekey).be;
		return SMOSequenceConversion(b.removeSMO(index));
	}

	public ClientOperatorSequence getInverseSMOs(String cookiekey) {
		BackendUtil b = clientstates.get(cookiekey).be;
		
		if(b instanceof ICBackendUtil)
			return SMOSequenceConversion(((ICBackendUtil)b).getInverseSMOs());
		return SMOSequenceConversion(b.getInverseSMOs());
	}

	public ClientQueryRewriteResult[] getRewriteResult(String cookiekey) {
		BackendUtil b = clientstates.get(cookiekey).be;
		
		if(b instanceof ICBackendUtil){
			return queryRewriteResultConversion(((ICBackendUtil)b).getQueryResults(b.schemaName));
		}	
		return queryRewriteResultConversion(b.getQueryResults(b.schemaName));
		
	}
	
	public SingleQueryRewriteResult rewriteQuery(String cookiekey,String query) {
		BackendUtil b = clientstates.get(cookiekey).be;
		if(b instanceof ICBackendUtil){
			return ((ICBackendUtil)b).rewriteQuery(query, b.schemaName);
		}	
		return b.rewriteQuery(query, b.schemaName);
		
	}

	private ClientQueryRewriteResult[] queryRewriteResultConversion(QueryRewriteResultSet queryResults) {
		Vector<QueryRewriteResult> qrr =  queryResults.results;
		ClientQueryRewriteResult[] r = new ClientQueryRewriteResult[qrr.size()];
		for(int i = 0 ; i< r.length;i++)
			r[i] = new ClientQueryRewriteResult(qrr.elementAt(i).inputqueries,qrr.elementAt(i).rewrittenqueries,qrr.elementAt(i).results);
		return r;
	}
	
	public String[] getViews(String cookiekey){
		BackendUtil b = clientstates.get(cookiekey).be;
		//SMOSequence ssh = b.getCurrentSMOs();
		//String[] view = b.getViews();
		return b.getViews();
	}
	
	public String[] getDM(String cookiekey) {
		BackendUtil b = clientstates.get(cookiekey).be;
		
		return b.getDM();
	}
	public ClientOperatorSequence editSMO(String cookiekey, int index, String smoText) {
		BackendUtil b = clientstates.get(cookiekey).be;
		return SMOSequenceConversion(b.editSMO(smoText,index));
	}
	
	public ClientOperatorSequence editInverseSMO(String cookiekey, String text,
			int major, int minor) {
		BackendUtil b = clientstates.get(cookiekey).be;
		return SMOSequenceConversion(b.editInverseSMO(text,major,minor));
	}

	
	public ClientSchema getCurrentSchema(String cookie,int schemaIndex) {
		
		if(clientstates.get(cookie).cs.error!=null){		
			ClientSchema s = new ClientSchema();
			s.error = clientstates.get(cookie).cs.error;
			return s;
		}
			
		BackendUtil b = clientstates.get(cookie).be;
		
		if(b == null)
			return null;
		
		if(b instanceof ICBackendUtil)
			return schemaConversion(((ICBackendUtil)b).getForwardSchema(schemaIndex),((ICBackendUtil)b).startingSchema);
		else
			return schemaConversion(b.getForwardSchema(schemaIndex),b.startingSchema);	
	}
	
	
	public ClientSchema getInverseSchema(String cookie,int schemaIndex) {
		BackendUtil b = clientstates.get(cookie).be;
	
		if(b instanceof ICBackendUtil)
			return schemaConversion(((ICBackendUtil)b).getInverseSchema(schemaIndex),((ICBackendUtil)b).startingSchema);
		else
			return schemaConversion(b.getInverseSchema(schemaIndex),b.startingSchema);
		
	}
	
	public ClientSchema getInverseSchemaByVersion(String cookie,int major, int minor) {
		BackendUtil b = clientstates.get(cookie).be;
		if(b instanceof ICBackendUtil)
			return schemaConversion(((ICBackendUtil)b).getInverseSchemaByVersion(major,minor),((ICBackendUtil)b).startingSchema);
		else
			return schemaConversion(b.getInverseSchemaByVersion(major,minor),b.startingSchema);
		
	}

	public String getDEDs(String cookiekey, boolean inverse) {
		BackendUtil b = clientstates.get(cookiekey).be;
		if(b instanceof ICBackendUtil){
			return ((ICBackendUtil)b).getDEDs(inverse);
		}	
		return b.getDEDs(inverse);
		
	}


	
}

