package edu.ucla.cs.dbevolution.DbBackend;

import java.util.ArrayList;
import java.util.List;

public class DbForeignKeyReference {


	private String fkeyName;
	private String tableName;
	private List<String> columnNames;
	private String referencedTableName;
	private List<String> referencedColumnNames;


	public String getFkeyName() {
		return fkeyName;
	}
	public void setFkeyName(String fkeyName) {
		this.fkeyName = fkeyName;
	}
	public String getTableName() {
		return tableName;
	}
	public void setTableName(String tableName) {
		this.tableName = tableName;
	}
	public List<String> getColumnNames() {
		return columnNames;
	}
	public void setColumnNames(List<String> columnNames) {
		this.columnNames = columnNames;
	}
	public String getReferencedTableName() {
		return referencedTableName;
	}
	public void setReferencedTableName(String referencedTableName) {
		this.referencedTableName = referencedTableName;
	}
	public List<String> getReferencedColumnNames() {
		return referencedColumnNames;
	}
	public void setReferencedColumnNames(List<String> referencedColumnNames) {
		this.referencedColumnNames = referencedColumnNames;
	}


	public static ArrayList<DbForeignKeyReference> getForeignKeyDefinition(List<DbKeyColumnUsage> keyColumns){
		
		
		String constraint_name = null;
		String table_name = null;
		String column_name = null;
		String referenced_table_name = null;
		String referenced_column_name = null;
		
		String temp_constraint_name = null;
		String temp_table_name = null;
		String temp_column_name = null;
		String temp_referenced_table_name = null;
		String temp_referenced_column_name = null;
		
		ArrayList<DbForeignKeyReference> keys = new ArrayList<DbForeignKeyReference>();
		
		DbForeignKeyReference fkey = new DbForeignKeyReference();
		
		ArrayList<String> columnNames = null;
		ArrayList<String> referencedColumnNames = null;

		DbKeyColumnUsage keyColumnTemp = null;

		if(keyColumns.size() > 1){
			DbKeyColumnUsage keyColumn = keyColumns.get(0);
		
			constraint_name = keyColumn.getCONSTRAINT_NAME();
			table_name = keyColumn.getTABLE_NAME();
			column_name = keyColumn.getCOLUMN_NAME();
			referenced_table_name = keyColumn.getREFERENCED_TABLE_NAME();
			referenced_column_name = keyColumn.getREFERENCED_COLUMN_NAME();
			
			columnNames = new ArrayList<String>();
			referencedColumnNames = new ArrayList<String>();
		
			fkey.setFkeyName(constraint_name);
			fkey.setTableName(table_name);
			fkey.setReferencedTableName(referenced_table_name);
			
			columnNames.add(column_name);
			referencedColumnNames.add(referenced_column_name);
			
			for(int i=1;i<keyColumns.size();i++){
				
				keyColumnTemp = keyColumns.get(i);
				
				temp_constraint_name = keyColumnTemp.getCONSTRAINT_NAME();
				temp_table_name = keyColumnTemp.getTABLE_NAME();
				temp_column_name = keyColumnTemp.getCOLUMN_NAME();
				temp_referenced_table_name = keyColumnTemp.getREFERENCED_TABLE_NAME();
				temp_referenced_column_name = keyColumnTemp.getREFERENCED_COLUMN_NAME();
				
				if(temp_constraint_name.equals(constraint_name) && temp_table_name.equals(table_name)){
					//same constraint, on the same table
					//the referenced table is the same, =====> multiple column foreign key
					referencedColumnNames.add(temp_referenced_column_name);
					columnNames.add(temp_column_name);
				}
				//BOTH THE CASE IN THE ELSE BRANCH
				//if(!temp_constraint_name.equals(constraint_name) && temp_table_name.equals(table_name)){
				//if(!temp_constraint_name.equals(constraint_name) && !temp_table_name.equals(table_name)){
					//different constraint_name,
					//different table_name
					// =========================> change of table
					//another table has a foreign key referencing the column
				else{
					//same table, different constraint_name ====> more than one foreign key defined on the same table using the referenced column
					
					//add the current foreign key to the list of foreign key references
					fkey.setReferencedColumnNames(referencedColumnNames);
					fkey.setColumnNames(columnNames);
					keys.add(fkey);
					
					//create a new foreign key reference,
					fkey = new DbForeignKeyReference();
					
					//create empty columns list
					columnNames = new ArrayList<String>();
					referencedColumnNames = new ArrayList<String>();
					
					columnNames.add(temp_column_name);
					referencedColumnNames.add(referenced_column_name);
					
					//add the constraint_name and temp_column_name
					fkey.setFkeyName(temp_constraint_name);
					fkey.setTableName(temp_table_name);
					fkey.setReferencedTableName(temp_referenced_table_name);
					
				}
			}
		}
		return keys;
	}
}
