package edu.ucla.cs.dbevolution.DbBackend;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;

import edu.ucla.cs.dbevolution.persistence.sqlDAO.SqlMapDAOManager;

public class DbKeyColumnUsage {

	private String CONSTRAINT_CATALOG;
	private String CONSTRAINT_SCHEMA;
	private String CONSTRAINT_NAME;
	private String TABLE_CATALOG;
	private String TABLE_SCHEMA;
	private String TABLE_NAME;
	private String COLUMN_NAME;
	private int ORDINAL_POSITION;
	private int POSITION_IN_UNIQUE_CONSTRAINT;
	private String REFERENCED_TABLE_SCHEMA;
	private String REFERENCED_TABLE_NAME;
	private String REFERENCED_COLUMN_NAME;
	
	/**
	 * Return the name of the columns composing the primary key
	 * @param table
	 * @param db
	 * @return
	 * @throws SQLException
	 */
//	public static LinkedHashMap<DbVersion, List<DbKeyColumnUsage>> getColumnsInPrimary(String tableName, String dbName) throws SQLException {
//
//		String sql = "	SELECT 	table_schema, column_name " +
//				"		FROM 	PRISM_KEY_COLUMN_USAGE s, PRISM_VERSIONS d " +
//				"		WHERE 	d.schema_unique_name =  s.table_schema AND " +
//				"				table_name = ? AND " +
//				"				table_schema like ? AND " +
//				"				constraint_name = ? " +
//				"		ORDER BY d.tstart";
//
//		LinkedHashMap<DbVersion, List<DbKeyColumnUsage>> columnsInPrimary = new LinkedHashMap<DbVersion, List<DbKeyColumnUsage>>();
//		ArrayList<DbKeyColumnUsage> dbColumns = null;
//		DbKeyColumnUsage dbColumn = null;
//		DbVersion db = null;
//
//		PreparedStatement pStmt = null;
//		ResultSet rs = null;
//		Connection conn = null;
//
//		String tempDbVersion;
//		String tempColumnName;
//		String currentColumnName = null;
//		String currentDbVersion = null;
//
//		try {
//			conn = DbUtil.connect(ApplicationParameters.getDbevolution());
//			pStmt = conn.prepareStatement(sql);
//			pStmt.setString(1,tableName);
//			pStmt.setString(2,dbName);
//			pStmt.setString(3,"PRIMARY");
//			rs = pStmt.executeQuery();
//
//			if(rs!= null){
//				rs.next();
//				tempDbVersion = rs.getString(1);
//				tempColumnName = rs.getString(2);
//
//				dbColumn = new DbKeyColumnUsage();
//				dbColumn.setCOLUMN_NAME(tempColumnName);
//				dbColumns = new ArrayList<DbKeyColumnUsage>();
//				dbColumns.add(dbColumn);
//
//				while(rs.next()){
//					currentDbVersion = rs.getString(1);
//					currentColumnName = rs.getString(2);
//					if(currentDbVersion.equals(tempDbVersion)){
//						dbColumn = new DbKeyColumnUsage();
//						dbColumn.setCOLUMN_NAME(currentColumnName);
//						dbColumns.add(dbColumn);
//					}
//					else{
//						db = new DbVersion();
//						db.setSchemaName(tempDbVersion);
//						columnsInPrimary.put(db, dbColumns);
//
//						//update the temporary schema name
//						tempDbVersion = currentDbVersion;
//
//						dbColumn = new DbKeyColumnUsage();
//						dbColumn.setCOLUMN_NAME(currentColumnName);
//						dbColumns = new ArrayList<DbKeyColumnUsage>();
//						dbColumns.add(dbColumn);
//					}
//				}
//				//add the last entry
//				db = new DbVersion();
//				db.setSchemaName(currentDbVersion);
//				columnsInPrimary.put(db, dbColumns);
//			}
//		}
//		catch(SQLException sEx){
//			sEx.printStackTrace();
//			throw sEx;
//		}
//		return columnsInPrimary;
//	}
	public static List<ColumnsInPrimaryBySchemaVersion> getColumnsInPrimary(String tableName, String dbName) throws SQLException {

		HashMap parametersMap = new HashMap(3);
		parametersMap.put("table_name",tableName);
		parametersMap.put("table_schema",dbName);
		parametersMap.put("constraint_name","PRIMARY");
		return (List<ColumnsInPrimaryBySchemaVersion>)SqlMapDAOManager.getSqlClient().queryForList("getColumnsInPrimaryKey",parametersMap);
	}
	
	
	
	
	
	public static List<DbKeyColumnUsage> getFKeyReferencesByColumn(String column, String table,String schema) throws SQLException{

//		Connection conn = null;
//		List<DbKeyColumnUsage> keyColumns = null;
//		DbKeyColumnUsage keyColumn = null;
//
//		String sql = "	SELECT table1.constraint_name, table1.table_name, column_name, table2.referenced_table_name, table2.referenced_column_name" +
//				"		FROM (" +
//				"				SELECT constraint_schema, table_name, constraint_name" +
//				"				FROM PRISM_KEY_COLUMN_USAGE" +
//				"				WHERE 	table_schema = ? AND" +
//				"						referenced_table_name = ? AND" +
//				"						referenced_column_name = ?) as table1, " +
//				"			PRISM_KEY_COLUMN_USAGE as table2" +
//				"		WHERE	table1.constraint_name = table2.constraint_name AND" +
//				"				table1.constraint_schema = table2.constraint_schema AND" +
//				"				table1.table_name = table2.table_name";
//
//		PreparedStatement pStmt = null;
//		ResultSet rs = null;
//
//		try{
//			
//			conn = DbUtil.connect(ApplicationParameters.getDbevolution());
//			pStmt = conn.prepareStatement(sql);
//			pStmt.setString(1,schema);
//			pStmt.setString(2,table);
//			pStmt.setString(3, column);
//
//			rs = pStmt.executeQuery();
//			if (rs != null) {
//				keyColumns = new ArrayList<DbKeyColumnUsage>();
//				while(rs.next()){
//					//add the constraint to the list of constraints 
//					keyColumn = new DbKeyColumnUsage();
//					keyColumn.CONSTRAINT_NAME = rs.getString(1);
//					keyColumn.TABLE_NAME = rs.getString(2);
//					keyColumn.COLUMN_NAME = rs.getString(3);
//					keyColumn.REFERENCED_TABLE_NAME = rs.getString(4);
//					keyColumn.REFERENCED_COLUMN_NAME = rs.getString(5);
//					keyColumns.add(keyColumn);
//				}
//			}
//		}
//		catch (SQLException sEx) {
//			System.err.println("An error is occured during executing statistic: "+ sEx.getMessage());
//			throw sEx;
//		} finally {
//			if(rs!=null){
//				rs.close();
//				rs=null;
//			}
//			if(pStmt!=null){
//				pStmt.close();
//				pStmt=null;
//			}
//			if(conn!=null){
//				conn.close();
//				conn=null;
//			}
//		}
//		return keyColumns;
		
		//List<DbKeyColumnUsage> keyColumns = null;
//		DbKeyColumnUsage col = new DbKeyColumnUsage();
//		col.setTABLE_SCHEMA(schema);
//		col.setREFERENCED_COLUMN_NAME(column);
//		col.setREFERENCED_TABLE_NAME(table);
		
		HashMap<String, String> parameters = new HashMap<String, String>(3);
		parameters.put("table_schema", schema);
		parameters.put("referenced_column_name", column);
		parameters.put("referenced_table_name", table);
		return (List<DbKeyColumnUsage>)SqlMapDAOManager.getSqlClient().queryForList("getFKeyReferencesByColumn",parameters);
	}
	

	public String getCONSTRAINT_CATALOG() {
		return CONSTRAINT_CATALOG;
	}

	public void setCONSTRAINT_CATALOG(String constraint_catalog) {
		CONSTRAINT_CATALOG = constraint_catalog;
	}

	public String getCONSTRAINT_SCHEMA() {
		return CONSTRAINT_SCHEMA;
	}

	public void setCONSTRAINT_SCHEMA(String constraint_schema) {
		CONSTRAINT_SCHEMA = constraint_schema;
	}

	public String getCONSTRAINT_NAME() {
		return CONSTRAINT_NAME;
	}

	public void setCONSTRAINT_NAME(String constraint_name) {
		CONSTRAINT_NAME = constraint_name;
	}

	public String getTABLE_CATALOG() {
		return TABLE_CATALOG;
	}

	public void setTABLE_CATALOG(String table_catalog) {
		TABLE_CATALOG = table_catalog;
	}

	public String getTABLE_SCHEMA() {
		return TABLE_SCHEMA;
	}

	public void setTABLE_SCHEMA(String table_schema) {
		TABLE_SCHEMA = table_schema;
	}

	public String getTABLE_NAME() {
		return TABLE_NAME;
	}

	public void setTABLE_NAME(String table_name) {
		TABLE_NAME = table_name;
	}

	public String getCOLUMN_NAME() {
		return COLUMN_NAME;
	}

	public void setCOLUMN_NAME(String column_name) {
		COLUMN_NAME = column_name;
	}

	public int getORDINAL_POSITION() {
		return ORDINAL_POSITION;
	}

	public void setORDINAL_POSITION(int ordinal_position) {
		ORDINAL_POSITION = ordinal_position;
	}

	public int getPOSITION_IN_UNIQUE_CONSTRAINT() {
		return POSITION_IN_UNIQUE_CONSTRAINT;
	}

	public void setPOSITION_IN_UNIQUE_CONSTRAINT(int position_in_unique_constraint) {
		POSITION_IN_UNIQUE_CONSTRAINT = position_in_unique_constraint;
	}

	public String getREFERENCED_TABLE_SCHEMA() {
		return REFERENCED_TABLE_SCHEMA;
	}

	public void setREFERENCED_TABLE_SCHEMA(String referenced_table_schema) {
		REFERENCED_TABLE_SCHEMA = referenced_table_schema;
	}

	public String getREFERENCED_TABLE_NAME() {
		return REFERENCED_TABLE_NAME;
	}

	public void setREFERENCED_TABLE_NAME(String referenced_table_name) {
		REFERENCED_TABLE_NAME = referenced_table_name;
	}

	public String getREFERENCED_COLUMN_NAME() {
		return REFERENCED_COLUMN_NAME;
	}

	public void setREFERENCED_COLUMN_NAME(String referenced_column_name) {
		REFERENCED_COLUMN_NAME = referenced_column_name;
	}
	
	
	
}
