package edu.ucla.cs.dbevolution.DbBackend;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.HashMap;

import org.apache.log4j.Logger;

import edu.ucla.cs.dbevolution.ApplicationParameters;

public class DbSchemata {

	private String SCHEMA_UNIQUE_NAME;
	private int schema_version;
	private int schema_version_minor;
	private String CATALOG_NAME;
	private String SCHEMA_NAME;
	private String DEFAULT_CHARACTER_SET_NAME;
	private String DEFAULT_COLLATION_NAME;
	private String SQL_PATH;
	private String comment;
	private String REVISION_NUMBER;
	private Timestamp TIMESTAMP;


	public String getSCHEMA_UNIQUE_NAME() {
		return SCHEMA_UNIQUE_NAME;
	}
	public void setSCHEMA_UNIQUE_NAME(String schema_unique_name) {
		SCHEMA_UNIQUE_NAME = schema_unique_name;
	}
	public int getSchema_version() {
		return schema_version;
	}
	public void setSchema_version(int schema_version) {
		this.schema_version = schema_version;
	}
	public int getSchema_version_minor() {
		return schema_version_minor;
	}
	public void setSchema_version_minor(int schema_version_minor) {
		this.schema_version_minor = schema_version_minor;
	}
	public String getCATALOG_NAME() {
		return CATALOG_NAME;
	}
	public void setCATALOG_NAME(String catalog_name) {
		CATALOG_NAME = catalog_name;
	}
	public String getSCHEMA_NAME() {
		return SCHEMA_NAME;
	}
	public void setSCHEMA_NAME(String schema_name) {
		SCHEMA_NAME = schema_name;
	}
	public String getDEFAULT_CHARACTER_SET_NAME() {
		return DEFAULT_CHARACTER_SET_NAME;
	}
	public void setDEFAULT_CHARACTER_SET_NAME(String default_character_set_name) {
		DEFAULT_CHARACTER_SET_NAME = default_character_set_name;
	}
	public String getDEFAULT_COLLATION_NAME() {
		return DEFAULT_COLLATION_NAME;
	}
	public void setDEFAULT_COLLATION_NAME(String default_collation_name) {
		DEFAULT_COLLATION_NAME = default_collation_name;
	}
	public String getSQL_PATH() {
		return SQL_PATH;
	}
	public void setSQL_PATH(String sql_path) {
		SQL_PATH = sql_path;
	}
	public String getComment() {
		return comment;
	}
	public void setComment(String comment) {
		this.comment = comment;
	}
	public String getREVISION_NUMBER() {
		return REVISION_NUMBER;
	}
	public void setREVISION_NUMBER(String revision_number) {
		REVISION_NUMBER = revision_number;
	}
	public Timestamp getTIMESTAMP() {
		return TIMESTAMP;
	}
	public void setTIMESTAMP(Timestamp timestamp) {
		TIMESTAMP = timestamp;
	}


	public static DbSchemata loadSchemataFromDb(boolean forward) throws SQLException{

		PreparedStatement ps = null;
		ResultSet rs = null;
		Connection conn = null;
		
		Logger log = Logger.getLogger(DbSchemata.class);
		
		HashMap<String, Object> params = new HashMap<String, Object>();
		params.put("VERSION",new Integer(ApplicationParameters.getRevisionNumber()));
		params.put("SCHEMA_NAME",ApplicationParameters.getDbbasename());
		
		DbSchemata sc = new DbSchemata();
		
		String sql = "	SELECT	sc.schema_version, sc.schema_version_minor, sc.DEFAULT_CHARACTER_SET_NAME, sc.DEFAULT_COLLATION_NAME," +
				"		sc.SQL_PATH, sc.comment, sc.REVISION_NUMBER, sc.TIMESTAMP" +
				"		FROM	SCHEMATA sc" +
				"		WHERE	sc.schema_version = ? AND" +
				"		sc.schema_name = ?";
		
		try{
			conn = DbUtil.connect(ApplicationParameters.getDbevolution());
			ps = conn.prepareStatement(sql);
			ps.setInt(1, ((Integer)params.get("VERSION")).intValue());
			ps.setString(2,(String)params.get("SCHEMA_NAME"));
			rs = ps.executeQuery();
			while(rs.next()){
				sc.setSchema_version(rs.getInt(1));
				sc.setSchema_version_minor(rs.getInt(2));
				sc.setDEFAULT_CHARACTER_SET_NAME(rs.getString(3));
				sc.setDEFAULT_COLLATION_NAME(rs.getString(4));
				sc.setSQL_PATH(rs.getString(5));
				sc.setComment(rs.getString(6));
				sc.setREVISION_NUMBER(rs.getString(7));
				sc.setTIMESTAMP(rs.getTimestamp(8));
			}
		}
		catch(SQLException sEx){
			log.fatal(sEx);
		}
		finally{
			conn.close();
			rs.close();
			ps.close();
			rs = null;
			ps = null;
		}
		return sc;
	}



}
