package edu.ucla.cs.dbevolution.DbBackend;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import org.apache.log4j.Logger;

import edu.ucla.cs.dbevolution.ApplicationParameters;

public class DbUtil {

	private static Logger log = Logger.getLogger(DbUtil.class);
	private static Connection conn;

	/**
	 * Open a connection towards the selected database and return a connection
	 * object
	 */
	public static Connection connect(String dbname) {
		Connection conn = null;
		try {
			createDriver();
			conn = (Connection) DriverManager.getConnection(
					ApplicationParameters.getDbbaseuri() + dbname,
					ApplicationParameters.getUser(), 
					ApplicationParameters.getPass());
		} catch (SQLException ex) {
			// handle any errors
			log.fatal("SQLException: ",  ex);
			log.fatal("SQLState: " + ex.getSQLState());
			log.fatal("VendorError: " + ex.getErrorCode());
			System.exit(-1);
		}
		return conn;
	}

	/**
	 * Create the driver for the connection
	 * 
	 */
	public static void createDriver() {
		try {
			// The newInstance() call is a work around for some
			// broken Java implementations
			Class.forName("com.mysql.jdbc.Driver").newInstance();
		} catch (Exception ex) {
			log.fatal(ex);
		}
	}
	
	/**
	 * Get a connection to the database
	 * @param dbname
	 * @return
	 * @throws SQLException
	 */
	public static Connection getConnection(String dbname) throws SQLException{
		if ((conn == null) && (conn.isClosed()) ){
			conn = connect(dbname);
		}
		return conn;
	}



}


