package edu.ucla.cs.dbevolution.DbBackend;

import java.sql.SQLException;
import java.util.List;

import org.apache.log4j.Logger;

import edu.ucla.cs.db.prism.backend.schema.Schema;
import edu.ucla.cs.db.prism.backend.schema.Table;
import edu.ucla.cs.dbevolution.ApplicationParameters;

public class PrismSchemaLoader {

	private static Logger logger = Logger.getLogger(PrismSchemaLoader.class);
	boolean debug = false;

	public static Schema loadSchemaFromDB(boolean forward, String schemaName) /*throws SQLException*/{

		int schemaVersion; 
		int schemaVersionMinor;
		Schema schema = null;

		DbSchemata schemata = null;
		
		try {
			schemata = DbSchemata.loadSchemataFromDb(true);

			schemaVersion = schemata.getSchema_version();
			schemaVersionMinor = schemata.getSchema_version_minor();

			schema = new Schema(schemata.getSchema_version(),
					schemata.getSchema_version_minor(),
					ApplicationParameters.getDbbasename(),
					schemata.getDEFAULT_CHARACTER_SET_NAME(),
					schemata.getDEFAULT_COLLATION_NAME(),
					schemata.getSQL_PATH(),
					schemata.getComment(),
					schemata.getREVISION_NUMBER(),									
					schemata.getTIMESTAMP(),
					null
			);
			schema.setSchemaName(schemaName);

			List<DbTable> tables = DbTable.getTableByVersionNumber(schemaVersion, schemaVersionMinor, schemaName);


			for(DbTable table: (List<DbTable>)tables){

				String tableName = table.getTABLE_NAME();

				List<DbColumn> columns = DbColumn.getColumnByTableAndVersionNumber(schemaVersion, schemaVersionMinor, schemaName, tableName);

				Table tt = new Table(tableName);
				String columnName = null;
				String columnType = null;
				for(DbColumn column: (List<DbColumn>)columns){
					columnName = column.getCOLUMN_NAME();
					columnType = column.getCOLUMN_TYPE();		
					tt.addColumn(columnName,columnType);		
				}
				schema.addTable(tt);
			}
		} catch (SQLException e) {
			logger.fatal(e);
			System.exit(-1);
		}
		return schema;
	}
}
