package edu.ucla.cs.dbevolution.DbBackend;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import edu.ucla.cs.dbevolution.ApplicationParameters;
import edu.ucla.cs.statistics.StatisticValue;

public class StatisticDbOperation {

	
	/**
	 * Get the count of the columns for every database
	 * @return a vector containing the count of the table for the selected schema
	 */
	public static Vector<StatisticValue> GetStatCount(String schema, String sql)throws SQLException {

		Vector<StatisticValue> chartValue = new Vector<StatisticValue>();

		Connection conn = null;
		PreparedStatement pStmt = null;
		ResultSet rs = null;

		try {
			conn = DbUtil.connect(ApplicationParameters.getDbevolution());
			pStmt = conn.prepareStatement(sql);
			pStmt.setString(1, schema + "%");

			rs = pStmt.executeQuery();
			if (rs != null) {
				while (rs.next()) {
					StatisticValue statColCount = new StatisticValue();
					statColCount.setX(rs.getString(1));
					statColCount.setY(rs.getInt(2));
					chartValue.add(statColCount);
				}
				rs.close();
				rs = null;
			}
			conn.close();
			conn = null;

			pStmt.close();
			pStmt = null;
		} catch (SQLException sEx) {
			System.out.println("An error is occured during executing statistic: "+ sEx.getMessage());
			throw sEx;
		}
		return chartValue;
	}


	
}
