/**
 * Copyright (C) 2009 
 * Developer: Fabrizio Moroni fabrizio.moroni@yahoo.it
 * Contributor: Carlo Curino	carlo@curino.us
 * 
 *  * This file is part of SchemEvolutionToolsuite
 * 
 * SchemEvolutionToolsuite is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SchemaEvolutionToolsuite is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with SchemEvolutionToolsuite.  If not, see <http://www.gnu.org/licenses/>.
 */

package edu.ucla.cs.dbevolution;

import java.io.File;
import java.util.Vector;

import edu.ucla.cs.dbevolution.DbBackend.DbVersion;

/**
 * The interfaces that must be implemented to enhance the reposity source
 * <br>Now the CVS and SVN are both supported.
 * <br>Implement this interface if you want to add a source (ex. text file) for retrieving revision data
 * @author fangar
 */
public interface Repository {

	/**
	 * Get all the revisions of the database schema from the repoisoty site
	 */
	public abstract Vector<DbVersion> GetRevisions();
		
	
	
	/**
	 * Download all the database schema corresponding to the revision 
	 */
	public abstract void DownloadRevision(String revision, File destination);
	
}
