/**
 * Copyright (C) 2009 
 * Developer: Fabrizio Moroni fabrizio.moroni@yahoo.it
 * Contributor: Carlo Curino	carlo@curino.us
 * 
 *  * This file is part of SchemEvolutionToolsuite
 * 
 * SchemEvolutionToolsuite is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SchemaEvolutionToolsuite is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with SchemEvolutionToolsuite.  If not, see <http://www.gnu.org/licenses/>.
 */

package edu.ucla.cs.statistics;

import java.text.DecimalFormat;

public class DatabaseSpecs {
	
	
	private String firstRelease;
	private String lastRelease;
	private int initialSize;
	private int endSize;
	private double databaseEvolutionRate;
	
	
	public String getFirstRelease() {
		return firstRelease;
	}
	public void setFirstRelease(String firstRelease) {
		this.firstRelease = firstRelease;
	}
	public String getLastRelease() {
		return lastRelease;
	}
	public void setLastRelease(String lastRelease) {
		this.lastRelease = lastRelease;
	}
	public int getInitialSize() {
		return initialSize;
	}
	public void setInitialSize(int initialSize) {
		this.initialSize = initialSize;
	}
	public int getEndSize() {
		return endSize;
	}
	public void setEndSize(int endSize) {
		this.endSize = endSize;
	}
	public double getDatabaseEvolutionRate() {
		return databaseEvolutionRate;
	}
	public void setDatabaseEvolutionRate(double databaseEvolutionRate) {
		this.databaseEvolutionRate = databaseEvolutionRate;
	}
	
	
	/**
	 * TODO
	 * @return
	 */
	public String getDatabaseEvolutionFactor() {
		
		//this.computeRiskFactor();
		//DecimalFormat format = new DecimalFormat("##.##");
		DecimalFormat format = new DecimalFormat("%");
		format.setPositivePrefix("");
		format.setPositiveSuffix("%");
		return format.format(getDatabaseEvolutionRate());
	}
	

}
