/**
 * Copyright (C) 2009 
 * Developer: Fabrizio Moroni fabrizio.moroni@yahoo.it
 * Contributor: Carlo Curino	carlo@curino.us
 * 
 *  * This file is part of SchemEvolutionToolsuite
 * 
 * SchemEvolutionToolsuite is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SchemaEvolutionToolsuite is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with SchemEvolutionToolsuite.  If not, see <http://www.gnu.org/licenses/>.
 */

package edu.ucla.cs.statistics;

import java.util.ArrayList;

import edu.ucla.cs.dbevolution.DbBackend.DbColumn;

public class Savepoint {

	
	private int columnsCount;
	private ArrayList<DbColumn> columnsName;
	
	
	
	
	public int getColumnsCount() {
		return columnsCount;
	}
	public void setColumnsCount(int columnsCount) {
		this.columnsCount = columnsCount;
	}
	
	
	/**
	 * @param s
	 * @param savepoint
	 * @return
	 */
	public boolean compareSavepoints(Savepoint s, Savepoint savepoint){
		
		if(compareColumnsCount(s, savepoint) && compareColumnsName(s, savepoint)){
			return true;
		}
		return  false;
		
	}
	
	/**
	 * @param s
	 * @param savepoint
	 * @return
	 */
	private boolean compareColumnsCount(Savepoint s, Savepoint savepoint){
		if(s.getColumnsCount() == savepoint.getColumnsCount()){
			return true;
		}
		return  false;
		
	}
	
	
	/**
	 * @param s
	 * @param savepoint
	 * @return
	 */
	private boolean compareColumnsName(Savepoint s, Savepoint savepoint){
		
		if(DbColumn.compareColumnsName(s.getColumnsName(),savepoint.getColumnsName()) ==0 && DbColumn.compareColumnsName(savepoint.getColumnsName(),s.getColumnsName())==0){
			return true;
		}
		return  false;
	}
	
//	/**
//	 * Get the difference between the tables of two different revisions
//	 * @param first the first revision to compare
//	 * @param second the second revision to compare
//	 * @return the number of tables different between the two revisions
//	 */
//	private int getDifference(Vector<String> first, Vector<String> second){
//		
//		int countDiff=0;
//		for(String table: first){
//			if(!second.contains(table)){
//				countDiff++;
//			}
//		}
//		return countDiff;
//	}
//	
//	
	public ArrayList<DbColumn> getColumnsName() {
		return columnsName;
	}
	public void setColumnsName(ArrayList<DbColumn> columnsName) {
		this.columnsName = columnsName;
	}
	

	
	
}
