package edu.ucla.cs.velocity.template;

import java.util.ArrayList;

import net.sf.jsqlparser.statement.create.table.ColumnDefinition;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;


public class AddColumnTemplate {

	
	private static Template getAddColumnTemplate(){
		return VelocityTemplateDispatcher.getVelocityTemplate("AddColumn.vm");
	}
	
	public static String getAddColumnSMO(ColumnDefinition colDef,String tableName,String asFunction){
		
		return getAddColumnSMO(colDef.getColumnName().getColumnName(), colDef.getColDataType().toString(), tableName, asFunction);
		
	}
	
	
	public static String getAddColumnSMO(String columnName,String dataType, String tableName,String asFunction){
		
		Template t = getAddColumnTemplate();
		VelocityContext context  = null;

		context = new VelocityContext();
		context.put("columnName",columnName);
		context.put("columnDataType",dataType);

		//no need for the function as id(..)
		//same table for each column definition
		context.put("tableName", tableName);
		if(asFunction != null)
			context.put("asFunction", asFunction);
		else
			context.put("asFunction", "");
		
		return VelocityTemplateDispatcher.mergeContextIntoString(context, t);
		
	}
	
	
	public static ArrayList<String> getAddColumnsSMOs(ArrayList<ColumnDefinition> columnsDefinition, String tableName,String asFunction){
		
		ArrayList<String> smos = new ArrayList<String>();
		
		for(ColumnDefinition colDef: columnsDefinition){

			smos.add(getAddColumnSMO(colDef, tableName,asFunction));
		}
		
		return smos;
	}
	
	
}
