package edu.ucla.cs.velocity.template;

import java.util.ArrayList;
import java.util.List;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;

import edu.ucla.cs.dbevolution.DbBackend.DbForeignKeyReference;


public class AddForeignKeyTemplate {

	
	private static Template getAddForeignKeyTemplate(){
		return VelocityTemplateDispatcher.getVelocityTemplate("AddForeignKey.vm");
	}
	
	public static String getAddForeignKeySMO(DbForeignKeyReference fkeyReference,String tableName){
		
		Template t = getAddForeignKeyTemplate();
		VelocityContext context;

		context = new VelocityContext();

		//create a context and add data
		context.put("tableName",tableName);
		context.put("foreignKeyName",fkeyReference.getFkeyName());
		context.put("foreignKeyColumns", fkeyReference.getColumnNames());
		context.put("referencedTableName", fkeyReference.getReferencedTableName());
		context.put("foreignKeyColumnsReferenced", fkeyReference.getReferencedColumnNames());
		return VelocityTemplateDispatcher.mergeContextIntoString(context, t);
		
	}
	
	
	public static ArrayList<String> getAddForeignKeySMOs(List<DbForeignKeyReference> refs,String tableName){
		ArrayList<String> smos = new ArrayList<String>(); 
		for(DbForeignKeyReference ref : refs ){
			smos.add(getAddForeignKeySMO(ref, tableName));
		}
		return smos;
	}
	
		
}
