package edu.ucla.cs.velocity.template;

import java.util.ArrayList;

import net.sf.jsqlparser.schema.Table;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;


public class CopyTableTemplate {

	private static final String tableCopySuffix = "_copy";
	
	private static Template getCopyTableTemplate(){
		return VelocityTemplateDispatcher.getVelocityTemplate("CopyTable.vm");
	}
	
	public static String getCopyTableSMO(Table table){
		
		Template t = getCopyTableTemplate();
		VelocityContext context  = null;
		
		context = new VelocityContext();
		context.put("sourceTable",table.getName());
		context.put("destinationTable",table.getName() + tableCopySuffix);
		
		return VelocityTemplateDispatcher.mergeContextIntoString(context, t);
		
	}
	
	public static String getCopyTableSMO(String table){
		
		Template t = getCopyTableTemplate();
		VelocityContext context  = null;
		
		context = new VelocityContext();
		context.put("sourceTable",table);
		context.put("destinationTable",table + tableCopySuffix);
		
		return VelocityTemplateDispatcher.mergeContextIntoString(context, t);
		
	}
	
	/**
	 * Get the name of the table will be assigned to the copy
	 * @param table
	 * @return
	 */
	public static String getCopiedTableName(Table table){
		return table.getName() + tableCopySuffix; 
	}
	
	/**
	 * Get the name of the table will be assigned to the copy
	 * @param table
	 * @return
	 */
	public static String getCopiedTableName(String table){
		return table + tableCopySuffix; 
	}
	
	
	public static ArrayList<String> getCopyTableSMOs(ArrayList<Table> tables){
		
		ArrayList<String> smos = new ArrayList<String>();
		
		for(Table table: tables){
			smos.add(getCopyTableSMO(table));
		}
		return smos;
	}
	
	
}
