package edu.ucla.cs.velocity.template;

import java.util.ArrayList;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;

import edu.ucla.cs.dbevolution.DbBackend.DbColumn;


public class DropColumnTemplate {

	
	private static Template getCopyTableTemplate(){
		return VelocityTemplateDispatcher.getVelocityTemplate("DropColumn.vm");
	}
	
	public static String getDropColumnSMO(DbColumn column){
		
		Template t = getCopyTableTemplate();
		VelocityContext context = new VelocityContext();
		context.put("columnName",column.getCOLUMN_NAME());
		context.put("tableName",column.getTABLE_NAME());
		
		return VelocityTemplateDispatcher.mergeContextIntoString(context, t);
		
	}
	
	public static String getDropColumnSMO(String columnsName, String tableName){
		
		Template t = getCopyTableTemplate();
		VelocityContext context = new VelocityContext();
		context.put("columnName",columnsName);
		context.put("tableName",tableName);
		
		return VelocityTemplateDispatcher.mergeContextIntoString(context, t);
		
	}
	
	
	public static ArrayList<String> getDropColumnSMOs(ArrayList<DbColumn> columns){
		
		ArrayList<String> smos = new ArrayList<String>();
		
		for(DbColumn column: columns){
			//TODO: check whether is possible to use just a single context and overwrite the velocity variable
			smos.add(getDropColumnSMO(column));
		}
		return smos;
	}
	
	
}
