package edu.ucla.cs.velocity.template;

import java.util.ArrayList;
import java.util.List;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;

import edu.ucla.cs.dbevolution.DbBackend.DbForeignKeyReference;


public class DropForeignKeyTemplate {

	
	private static Template getDropForeignKeyTemplate(){
		return VelocityTemplateDispatcher.getVelocityTemplate("DropForeignKey.vm");
	}
	
	public static String getDropForeignKeySMO(DbForeignKeyReference fkeyReference){
		
		Template t = getDropForeignKeyTemplate();
		VelocityContext context;

		context = new VelocityContext();
		//create a context and add data
		context.put("foreignKeyName",fkeyReference.getFkeyName());
		context.put("tableName",fkeyReference.getTableName());
		return VelocityTemplateDispatcher.mergeContextIntoString(context, t);
		
	}
	
	public static ArrayList<String> getDropForeignKeySMOs(List<DbForeignKeyReference> refs){
		ArrayList<String> smos = new ArrayList<String>();
		for(DbForeignKeyReference ref: refs){
			smos.add(getDropForeignKeySMO(ref));
		}
		return smos;
	}
	
		
}
