package edu.ucla.cs.velocity.template;

public class PartitionTemplateSource {

	private String tableName;
	private String tablePartition1;
	private String tablePartition2;
	private String partitionCondition1;
	private String partitionCondition2;
	
	public static final String partition1Suffix = "_part1";
	public static final String partition2Suffix = "_part2"; 
	
	
	/**
	 * Get the name of the USEFUL partition
	 * @param tableName
	 * @return
	 */
	public static String getKeptPartitionTable(String tableName){
		return tableName + partition1Suffix;
	}
	
	/**
	 * Get the name of the USELESS partition
	 * @param tableName
	 * @return
	 */
	public static String getDroppedPartitionTable(String tableName){
		return tableName + partition2Suffix;
	}
	
	public String getTableName() {
		return tableName;
	}
	public void setTableName(String tableName) {
		this.tableName = tableName;
	}
	public String getTablePartition1() {
		return tablePartition1;
	}
	public void setTablePartition1(String tablePartition1) {
		this.tablePartition1 = tablePartition1 + partition1Suffix;
	}
	public String getTablePartition2() {
		return tablePartition2;
	}
	public void setTablePartition2(String tablePartition2) {
		this.tablePartition2 = tablePartition2 + partition2Suffix;
	}
	public String getPartitionCondition1() {
		return partitionCondition1;
	}
	public void setPartitionCondition1(String partitionCondition1) {
		this.partitionCondition1 = partitionCondition1;
	}
	public String getPartitionCondition2() {
		return partitionCondition2;
	}
	public void setPartitionCondition2(String partitionCondition2) {
		this.partitionCondition2 = partitionCondition2;
	}
	
	
	
}
