/* ================================================================
 * JSQLParser : java based sql parser 
 * ================================================================
 *
 * Project Info:  http://jsqlparser.sourceforge.net
 * Project Lead:  Leonardo Francalanci (leoonardoo@yahoo.it);
 *
 * (C) Copyright 2004, by Leonardo Francalanci
 *
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation;
 * either version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with this
 * library; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

package net.sf.jsqlparser.statement.drop;

import net.sf.jsqlparser.schema.Index;
import net.sf.jsqlparser.schema.Table;
import net.sf.jsqlparser.statement.StatementVisitor;

/**
 * A DROP INDEX statement
 * <br>Syntax:
 * <br>DROP [ONLINE|OFFLINE] INDEX index_name ON tbl_name
 * @author fangar
 *
 */
public class DropIndex implements Drop{

	private Index index;
	private Table table;

	public Index getIndex() {
		return index;
	}

	public void setIndex(Index index) {
		this.index = index;
	}

	@Override
	public void accept(StatementVisitor statementVisitor) {
		// TODO Auto-generated method stub
		
	}

	public Table getTable() {
		return table;
	}

	public void setTable(Table table) {
		this.table = table;
	}
	
	public String toString(){
		String sql ="";
		sql += "DROP INDEX ";
		sql += getIndex().getName();
		sql += getTable()!=null?" ON " + getTable().getName():"";
		
		return sql;
	}
	
}
